#include "gd.h"
#include "gdfontt.h"
#include "gdfonts.h"
#include "gdfontmb.h"
#include "gdfontl.h"
#include "gdfontg.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <memory.h>

void img_plotinit();
void img_plotend();
void img_clear();
void img_cleararea();
void img_line();
void img_moveto();
void img_lineto();
void img_rlineto();
void img_translate();
void img_plot();
void img_polygon();
void img_rect();
void img_circle();
void img_triangle();
void img_triangle1();
void img_triangle2();
void img_triangle3();
void img_square();
void img_diamond();
void img_plus();
void img_times();
void img_vector();
void img_text();
void img_setbkcolor();
void img_setcolor();
void img_alloccolor();
void img_setqbcolor();
void img_setfont();
void img_setline();
void img_setdash();
void img_setgrayshade();
void xy2ixiy();

static gdImagePtr im;
static FILE *out;
static int width, height;
static float scale;
static int ncolor = -1;
static int color;
static int pixel[64];
static int font = 0;
static int lw;
static int bgcolor;
static float comX = 0.0;
static float comY = 0.0;
static float orgX = 0.0;
static float orgY = 0.0;

static int RGB[64][3] = { 0, 0, 0, 0, 0, 255, 0, 255, 0, 0, 255, 255, 255, 0, 0, 255, 0, 255, 255,
    255, 0, 255, 255, 255,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    255, 0, 0, 255, 32, 0, 255, 65, 0, 255, 98, 0, 255, 131, 0, 255, 164, 0,
    255, 197, 0, 255, 230, 0,
    246, 255, 0, 213, 255, 0, 180, 255, 0, 148, 255, 0, 115, 255, 0, 82, 255, 0,
    49, 255, 0, 16, 255, 0,
    0, 255, 16, 0, 255, 49, 0, 255, 82, 0, 255, 115, 0, 255, 148, 0, 255, 180,
    0, 255, 213, 0, 255, 246,
    0, 230, 255, 0, 197, 255, 0, 164, 255, 0, 131, 255, 0, 98, 255, 0, 65, 255,
    0, 32, 255, 0, 0, 255
};

void img_plotinit(iwin, filename, x0, y0, xsize, ysize, fscale)
int iwin;
char *filename;
float x0, y0, xsize, ysize, fscale;
{
    int i;
    scale = 2.4;
    ncolor = -1;
    font = 0;
    scale = scale * fscale;
    width = scale * xsize;
    height = scale * ysize;
    im = gdImageCreate(width, height);
    color = gdImageColorAllocate(im, 0, 0, 0);
    bgcolor = gdImageColorAllocate(im, 255, 255, 255);
    gdImageFilledRectangle(im, 0, 0, width, height, bgcolor);
    for (i = 0; i < 64; i++) {
	pixel[i] = gdImageColorAllocate(im, RGB[i][0], RGB[i][1], RGB[i][2]);
    }
/*
	pixel[0] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[1] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[2] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[3] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[4] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[5] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[6] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[7] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[8] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[9] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[10] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[11] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[12] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[13] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[14] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[15] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[16] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[17] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[18] = gdImageColorAllocate(im, 0, 0, 0);
	pixel[19] = gdImageColorAllocate(im, 0, 0, 0);
 */
    out = fopen(filename, "wb");
}

void img_line(iwin, x1, y1, x2, y2)
int iwin;
float x1, y1, x2, y2;
{
    int ix1, iy1, ix2, iy2;
    xy2ixiy(x1, y1, &ix1, &iy1);
    xy2ixiy(x2, y2, &ix2, &iy2);
    /*
     * printf("%(x1, y1) = %d %d (x2, y2) = %d %d\n", ix1, iy1, ix2,
     * iy2);
     */
    gdImageLine(im, ix1, iy1, ix2, iy2, color);
    if (lw > 1) {
	gdImageLine(im, ix1, iy1 + 1, ix2, iy2 + 1, color);
	gdImageLine(im, ix1 + 1, iy1, ix2 + 1, iy2, color);
    }
}

void img_translate(iwin, x, y)
int iwin;
float x, y;
{
    orgX += x;
    orgY += y;
}

void img_moveto(iwin, x, y)
int iwin;
float x, y;
{
    comX = x;
    comY = y;
}

void img_lineto(iwin, x, y)
int iwin;
float x, y;
{
    int ix1, iy1, ix2, iy2;
    xy2ixiy(comX, comY, &ix1, &iy1);
    xy2ixiy(x, y, &ix2, &iy2);
    /*
     * printf("%(x1, y1) = %d %d (x2, y2) = %d %d\n", ix1, iy1, ix2,
     * iy2);
     */
    gdImageLine(im, ix1, iy1, ix2, iy2, color);
    if (lw > 1) {
	gdImageLine(im, ix1, iy1 + 1, ix2, iy2 + 1, color);
	gdImageLine(im, ix1 + 1, iy1, ix2 + 1, iy2, color);
    }
    comX = x;
    comY = y;
}

void img_rlineto(iwin, dx, dy)
int iwin;
float dx, dy;
{
    int ix1, iy1, ix2, iy2;
    xy2ixiy(comX, comY, &ix1, &iy1);
    xy2ixiy(comX + dx, comY + dy, &ix2, &iy2);
    /*
     * printf("%(x1, y1) = %d %d (x2, y2) = %d %d\n", ix1, iy1, ix2,
     * iy2);
     */
    gdImageLine(im, ix1, iy1, ix2, iy2, color);
    if (lw > 1) {
	gdImageLine(im, ix1, iy1 + 1, ix2, iy2 + 1, color);
	gdImageLine(im, ix1 + 1, iy1, ix2 + 1, iy2, color);
    }
    comX += dx;
    comY += dy;
}

void img_plotend(iwin, end)
int iwin;
int end;
{
    if (iwin == 11) {
	gdImagePng(im, out);
    } else {
	gdImageJpeg(im, out, -1);
/*
		gdImageJpeg(im, out,95);
 */
    }
    fclose(out);
    gdImageDestroy(im);
}

void img_clear(iwin)
int iwin;
{
    ;
}

void img_cleararea(iwin, x1, y1, x2, y2)
int iwin;
float x1, y1, x2, y2;
{
    ;
}

void img_plot(iwin, x, y, n)
int iwin;
float x[], y[];
int n;
{
    int i;
    for (i = 0; i < n - 1; i++) {
	img_line(iwin, x[i], y[i], x[i + 1], y[i + 1]);
    }
}

void img_polygon(iwin, x, y, n, outline)
int iwin;
float x[], y[];
int n;
int outline;
{
    int i;
    gdPoint points[4096];
    for (i = 0; i < n; i++) {
	xy2ixiy(x[i], y[i], &points[i].x, &points[i].y);
    }
    if (outline == 1) {
	gdImagePolygon(im, points, n, color);
    } else {
	gdImageFilledPolygon(im, points, n, color);
    }
}

void img_rect(iwin, x, y, wx, wy, outline)
int iwin;
float x, y, wx, wy;
int outline;
{
    float x1, y1, x2, y2;
    int ix1, iy1, ix2, iy2;
    x1 = x;
    y1 = y + wy;
    x2 = x + wx;
    y2 = y;
    xy2ixiy(x1, y1, &ix1, &iy1);
    xy2ixiy(x2, y2, &ix2, &iy2);
    if (outline == 1) {
	gdImageRectangle(im, ix1, iy1, ix2, iy2, color);
	if (lw > 1) {
	    gdImageRectangle(im, ix1 + 1, iy1 + 1, ix2 - 1, iy2 - 1, color);
	}
    } else {
	gdImageFilledRectangle(im, ix1, iy1, ix2, iy2, color);
    }
}

void img_symbol(iwin, x, y, size, symbol, outline)
int iwin;
float x, y, size;
int symbol;
int outline;
{
    float rr;
    if (symbol == 1)
	img_circle(iwin, x, y, size / 2., outline);
    else if (symbol == 2)
	img_square(iwin, x, y, size, outline);
    else if (symbol == 3)
	img_plus(iwin, x, y, size, outline);
    else if (symbol == 4)
	img_triangle(iwin, x, y, size, outline);
    else if (symbol == 5)
	img_diamond(iwin, x, y, size / sqrt(2.0), outline);
    else if (symbol == 6)
	img_triangle1(iwin, x, y, size, outline);
    else if (symbol == 7)
	img_triangle2(iwin, x, y, size, outline);
    else if (symbol == 8)
	img_triangle3(iwin, x, y, size, outline);
    else if (symbol == 9)
	img_times(iwin, x, y, size, outline);
}


void img_circle(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    /*
     * int ix, iy; int isize, idum; xy2ixiy(x, y, &ix, &iy);
     * xy2ixiy(size, size, &isize, &idum); if (outline == 1){
     * gdImageArc(im, ix, iy, isize, isize, 0, 360, color); } else {
     * gdImageArc(im, ix, iy, isize, isize, 0, 360, color);
     * gdImageFill(im, ix, iy, color); }
     */
    int i;
    gdPoint points[361];
    float px[361], py[361];
    float rad = 3.14159 / 180.;
    int n;
    float deg, r;
    r = size;
    /*
     * n = (int) r / 2 + 60; if ( n > 180 ) n = 180;
     */
    n = 180;
    deg = 360. / (float) n;
    for (i = 0; i < n; i++) {
	px[i] = x + r * cos(rad * deg * i);
	py[i] = y + r * sin(rad * deg * i);
	xy2ixiy(px[i], py[i], &points[i].x, &points[i].y);
    }
    if (outline == 1)
	gdImagePolygon(im, points, n, color);
    else
	gdImageFilledPolygon(im, points, n, color);
}

void img_triangle(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    int i;
    int ix, iy;
    float px[3], py[3];
    gdPoint points[3];
    px[0] = x;
    py[0] = y + 0.57736 * size;
    px[1] = x - 0.5 * size;
    py[1] = y - 0.28867 * size;
    px[2] = x + 0.5 * size;
    py[2] = y - 0.28867 * size;
    for (i = 0; i < 3; i++) {
	xy2ixiy(px[i], py[i], &points[i].x, &points[i].y);
    }
    if (outline == 1) {
	gdImagePolygon(im, points, 3, color);
    } else {
	gdImageFilledPolygon(im, points, 3, color);
    }
}

void img_triangle1(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    int i;
    int ix, iy;
    float px[3], py[3];
    gdPoint points[3];
    px[0] = x - 0.57736 * size;
    py[0] = y;
    px[1] = x + 0.28867 * size;
    py[1] = y - 0.5 * size;
    px[2] = px[1];
    py[2] = y + 0.5 * size;
    for (i = 0; i < 3; i++) {
	xy2ixiy(px[i], py[i], &points[i].x, &points[i].y);
    }
    if (outline == 1) {
	gdImagePolygon(im, points, 3, color);
    } else {
	gdImageFilledPolygon(im, points, 3, color);
    }
}

void img_triangle2(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    int i;
    int ix, iy;
    float px[3], py[3];
    gdPoint points[3];
    px[0] = x - 0.5 * size;
    py[0] = y + 0.28867 * size;
    px[1] = x;
    py[1] = y - 0.57736 * size;
    px[2] = x + 0.5 * size;
    py[2] = py[0];
    for (i = 0; i < 3; i++) {
	xy2ixiy(px[i], py[i], &points[i].x, &points[i].y);
    }
    if (outline == 1) {
	gdImagePolygon(im, points, 3, color);
    } else {
	gdImageFilledPolygon(im, points, 3, color);
    }
}

void img_triangle3(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    int i;
    int ix, iy;
    float px[3], py[3];
    gdPoint points[3];
    px[0] = x + 0.57736 * size;
    py[0] = y;
    px[1] = x - 0.28867 * size;
    py[1] = y - 0.5 * size;
    px[2] = px[1];
    py[2] = y + 0.5 * size;
    for (i = 0; i < 3; i++) {
	xy2ixiy(px[i], py[i], &points[i].x, &points[i].y);
    }
    if (outline == 1) {
	gdImagePolygon(im, points, 3, color);
    } else {
	gdImageFilledPolygon(im, points, 3, color);
    }
}


void img_square(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float x1, y1, x2, y2;
    int ix1, iy1, ix2, iy2;
    x1 = x - 0.5 * size;
    y1 = y + 0.5 * size;
    x2 = x + 0.5 * size;
    y2 = y - 0.5 * size;
    xy2ixiy(x1, y1, &ix1, &iy1);
    xy2ixiy(x2, y2, &ix2, &iy2);
    if (outline == 1) {
	gdImageRectangle(im, ix1, iy1, ix2, iy2, color);
    } else {
	gdImageFilledRectangle(im, ix1, iy1, ix2, iy2, color);
    }
}

void img_diamond(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    int i;
    int ix, iy;
    float px[4], py[4];
    gdPoint points[4];
    px[0] = x;
    py[0] = y + 0.7071 * size;
    px[1] = x - 0.7071 * size;
    py[1] = y;
    px[2] = x;
    py[2] = y - 0.7071 * size;
    px[3] = x + 0.7071 * size;
    py[3] = y;
    for (i = 0; i < 4; i++) {
	xy2ixiy(px[i], py[i], &points[i].x, &points[i].y);
    }
    if (outline == 1) {
	gdImagePolygon(im, points, 4, color);
    } else {
	gdImageFilledPolygon(im, points, 4, color);
    }
}

void img_plus(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float x1, y1, x2, y2;
    int ix1, iy1, ix2, iy2, ix, iy;
    x1 = x - 0.5 * size;
    y1 = y - 0.5 * size;
    x2 = x + 0.5 * size;
    y2 = y + 0.5 * size;
    /*
     * xy2ixiy(x1, y1, &ix1, &iy1);  xy2ixiy(x1, y1, &ix2, &iy2);
     * xy2ixiy(x, y, &ix, &iy); gdImageLine(im ,ix1, iy, ix2, iy, color);
     * gdImageLine(im, ix, iy1, ix, iy2, color);
     */
    img_line(iwin, x1, y, x2, y);
    img_line(iwin, x, y1, x, y2);
}


void img_times(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float x1, y1, x2, y2;
    int ix1, iy1, ix2, iy2;
    x1 = x - 0.5 * size;
    y1 = y - 0.5 * size;
    x2 = x + 0.5 * size;
    y2 = y + 0.5 * size;
    /*
     * xy2ixiy(x1, y1, &ix1, &iy1);  xy2ixiy(x1, y1, &ix2, &iy2);
     * gdImageLine(im, ix1, iy1, ix2, iy2, color); gdImageLine(im, ix1,
     * iy2, ix2, iy1, color);
     */
    img_line(iwin, x1, y1, x2, y2);
    img_line(iwin, x1, y2, x2, y1);
}

void img_vector(iwin, x, y, direction, length, aw, hl, hw, outline)
int iwin;
float x, y, direction, length;
float aw, hl, hw;
int outline;
{
    int i;
    float xx[7], yy[7], rad;
    gdPoint points[7];
    rad = 3.14159 / 180.;
    hw = 1.5 * hw;
    xx[0] = x + 0.5 * aw * cos(rad * (direction + 90.));
    yy[0] = y + 0.5 * aw * sin(rad * (direction + 90.));
    xx[1] = xx[0] + (length - hl) * cos(rad * direction);
    yy[1] = yy[0] + (length - hl) * sin(rad * direction);
    xx[2] = xx[1] + (hw - aw) / 2. * cos(rad * (direction + 90.));
    yy[2] = yy[1] + (hw - aw) / 2. * sin(rad * (direction + 90.));
    xx[3] = x + length * cos(rad * direction);
    yy[3] = y + length * sin(rad * direction);
    xx[4] = x + (length - hl) * cos(rad * direction) + 0.5 * (hw - aw) * cos(rad * (direction - 90.));
    yy[4] = y + (length - hl) * sin(rad * direction) + 0.5 * (hw - aw) * sin(rad * (direction - 90.));
    xx[5] = x + (length - hl) * cos(rad * direction) + 0.5 * aw * cos(rad * (direction - 90.));
    yy[5] = y + (length - hl) * sin(rad * direction) + 0.5 * aw * sin(rad * (direction - 90.));
    xx[6] = x + 0.5 * aw * cos(rad * (direction - 90.));
    yy[6] = y + 0.5 * aw * sin(rad * (direction - 90.));
    for (i = 0; i < 7; i++) {
	xy2ixiy(xx[i], yy[i], &points[i].x, &points[i].y);
    }
    if (outline == 1) {
	gdImagePolygon(im, points, 7, color);
    } else {
	gdImageFilledPolygon(im, points, 7, color);
    }
}

void img_alloccolor(iwin, no, r, g, b)
int iwin;
int no, r, g, b;
{
    pixel[no] = gdImageColorAllocate(im, r, g, b);
/*
	rgb[no][0]=r;
	rgb[no][1]=g;
	rgb[no][2]=b;
 */
}

void img_setbkcolor(iwin, r, g, b)
int iwin;
int r, g, b;
{
    bgcolor = gdImageColorAllocate(im, r, g, b);
    gdImageFilledRectangle(im, 0, 0, width, height, bgcolor);
}

void img_setcolor(iwin, r, g, b)
int iwin;
int r, g, b;
{
    static int rr[512], gg[512], bb[512];
    static int nindex[512];
    int j, flag;
    flag = 0;
    for (j = 0; j < ncolor; j++) {
	if (r == rr[j] && g == gg[j] && b == bb[j]) {
	    color = nindex[j];
	    flag = 1;
	    break;
	}
    }
    if (flag == 0) {
	ncolor++;
	rr[ncolor] = r;
	gg[ncolor] = g;
	bb[ncolor] = b;
	nindex[ncolor] = gdImageColorAllocate(im, r, g, b);
	color = nindex[ncolor];
    }
/*
		nindex[ncolor] = gdImageColorAllocate(im, r, g, b);
		color = nindex[ncolor];
 */
/*
	output = gdImageColorAllocate(im, r, g, b);
 */
}

void img_setqbcolor(iwin, no)
int iwin;
int no;
{
    color = pixel[no];
/*
	int r, g, b;
	r = rgb[no][0];
	g = rgb[no][1];
	b = rgb[no][2];
	color = gdImageColorAllocate(im, r, g, b);
 */

}

void img_setfont(iwin, fontno)
int iwin;
int fontno;
{
    font = fontno;
}


void img_setline(iwin, linewidth)
int iwin;
int linewidth;
{
    lw = linewidth / 2;
}

void img_setdash(iwin, dashtype)
int iwin;
int dashtype;
{
    ;
}


void img_setgrayshade(iwin, grayshade)
int iwin;
int grayshade;
{
    ;
}

int img_setgrayshade_(iwin, grayshade)
int *iwin;
int *grayshade;
{
    img_setgrayshade(*iwin, *grayshade);
}

void img_string(iwin, xin, yin, size, text, angle, ntext, ipos)
int iwin, size;
float xin, yin, angle;
char *text;
int ntext;
int ipos;
{
    int fonth, fontw;
    int ix, iy, ixin, iyin;
    xy2ixiy(xin, yin, &ixin, &iyin);
    switch (size) {
    case -2:
	fonth = 8;
	fontw = 5;
	break;
    case -1:
	fonth = 12;
	fontw = 6;
	break;
    case 0:
	fonth = 13;
	fontw = 7;
	break;
    case 1:
	fonth = 16;
	fontw = 8;
	break;
    case 2:
	fonth = 15;
	fontw = 9;
	break;
    }
    if (angle == 0.0) {
	switch (ipos) {
	case 1:
	    ix = ixin;
	    iy = iyin - fonth;
	    break;
	case 2:
	    ix = ixin - fontw * ntext / 2.0;
	    iy = iyin - fonth;
	    break;
	case 3:
	    ix = ixin - fontw * ntext;
	    iy = iyin - fonth;
	    break;
	case 4:
	    ix = ixin;
	    iy = iyin - fonth / 2.;
	    break;
	case 5:
	    ix = ixin - fontw * ntext / 2.0;
	    iy = iyin - fonth / 2.0;
	    break;
	case 6:
	    ix = ixin - fontw * ntext;
	    iy = iyin - fonth / 2.0;
	    break;
	case 7:
	    ix = ixin;
	    iy = iyin;
	    break;
	case 8:
	    ix = ixin - fontw * ntext / 2.;
	    iy = iyin;
	    break;
	case 9:
	    ix = ixin - fontw * ntext;
	    iy = iyin;
	    break;
	}
	switch (size) {
	case -2:
	    gdImageString(im, gdFontTiny, ix, iy, text, color);
	    break;
	case -1:
	    gdImageString(im, gdFontSmall, ix, iy, text, color);
	    break;
	case 0:
	    gdImageString(im, gdFontMediumBold, ix, iy, text, color);
	    break;
	case 1:
	    gdImageString(im, gdFontLarge, ix, iy, text, color);
	    break;
	case 2:
	    gdImageString(im, gdFontGiant, ix, iy, text, color);
	    break;
	}
    } else if (angle == 90.0) {
	switch (ipos) {
	case 1:
	    ix = ixin - fonth;
	    iy = iyin;
	    break;
	case 2:
	    ix = ixin - fonth;
	    iy = iyin + fontw * ntext / 2.0;
	    break;
	case 3:
	    ix = ixin - fonth;
	    iy = iyin + fontw * ntext;
	    break;
	case 4:
	    ix = ixin - fonth / 2.;
	    iy = iyin;
	    break;
	case 5:
	    ix = ixin - fonth / 2.0;
	    iy = iyin + fontw * ntext / 2.0;
	    break;
	case 6:
	    ix = ixin - fonth / 2.0;
	    iy = iyin + fontw * ntext;
	    break;
	case 7:
	    ix = ixin;
	    iy = iyin;
	    break;
	case 8:
	    ix = ixin;
	    iy = iyin + fontw * ntext / 2.;
	    break;
	case 9:
	    ix = ixin;
	    iy = iyin + fontw * ntext;
	    break;
	}
	switch (size) {
	case -2:
	    gdImageStringUp(im, gdFontTiny, ix, iy, text, color);
	    break;
	case -1:
	    gdImageStringUp(im, gdFontSmall, ix, iy, text, color);
	    break;
	case 0:
	    gdImageStringUp(im, gdFontMediumBold, ix, iy, text, color);
	    break;
	case 1:
	    gdImageStringUp(im, gdFontLarge, ix, iy, text, color);
	    break;
	case 2:
	    gdImageStringUp(im, gdFontGiant, ix, iy, text, color);
	    break;
	}
    }
}

void img_text(iwin, xin, yin, size, text, angle, ntext, ipos)
int iwin;
float xin, yin, size, angle;
char *text;
int ntext;
int ipos;
{
    /*
       7       8        9 
       |~~~~~~~~~~~~~~~~| 
       |4      +5      6|
       |________________| 
       1       2        3
     */
    float sizemod, csize, radn, propotion;
    static int id[128], ic[1200];
    int idata[128];
    int textwidth, ixc, iyc, l, icndx, istrk, istyp;
    char s[1];
    int i, npen;
    float x, y, sine, cosin, sxloc, syloc, xct, yct, xchar;
    float x1, y1, xc, yc;
    int static load;
    if (load != 1) {
#include "font.h"
	load = 1;
    }
    img_setline(iwin, 1);
    img_setdash(iwin, 1);
    /* sizemod=0.600;  */
    sizemod = 0.750;
    csize = size / 21. * sizemod;	/* by Tsuru */
    radn = angle * 0.017453;
    propotion = 1.0;
    /* CALICULATION OF TEXT WIDTH  */
    for (i = 0; i < ntext; i++) {
	s[0] = text[i];
	idata[i] = s[0];
    }
    textwidth = 0.;
    for (i = 0; i < ntext; i++) {
	l = idata[i];		/* l is ascii code no */
	icndx = id[l + 1] - 1;	/* icndx is last data of text[i] */

	istrk = ic[icndx];
	istyp = istrk / 10000;
	ixc = ((istrk - (istyp * 10000)) / 100) - 10;
	iyc = istrk - (istyp * 10000) - ((ixc + 10) * 100) - 11;
	textwidth = textwidth + ixc;
    }

    xchar = (float) (textwidth) * sizemod / 21.;

    switch (ipos) {
    case 1:
	x = xin;
	y = yin;
	break;
    case 2:
	x = xin - cos(radn) * size * xchar / 2.;
	y = yin - sin(radn) * size * xchar / 2.;
	break;
    case 3:
	x = xin - cos(radn) * size * xchar;
	y = yin - sin(radn) * size * xchar;
	break;
    case 4:
	x = xin + sin(radn) * size / 2.;
	y = yin - cos(radn) * size / 2.;
	break;
    case 5:
	x = xin - cos(radn) * size * xchar / 2. + sin(radn) * size / 2.;
	y = yin - sin(radn) * size * xchar / 2. - cos(radn) * size / 2.;
	break;
    case 6:
	x = xin - cos(radn) * size * xchar + sin(radn) * size / 2.;
	y = yin - sin(radn) * size * xchar - cos(radn) * size / 2.;
	break;
    case 7:
	x = xin + sin(radn) * size;
	y = yin - cos(radn) * size;
	break;
    case 8:
	x = xin - cos(radn) * size * xchar / 2. + sin(radn) * size;
	y = yin - sin(radn) * size * xchar / 2. - cos(radn) * size;
	break;
    case 9:
	x = xin - cos(radn) * size * xchar + sin(radn) * size;
	y = yin - sin(radn) * size * xchar - cos(radn) * size;
	break;
    }
    sine = sin(radn);
    cosin = cos(radn);
    if (angle == 90.) {
	sine = 1.0;
	cosin = 0.;
    }
    x1 = x;
    y1 = y;
    sxloc = x;
    syloc = y;

    for (i = 0; i < ntext; i++) {
	l = idata[i];
	icndx = id[l];
	do {
	    istrk = ic[icndx];
	    istyp = istrk / 10000;
	    ixc = ((istrk - (istyp * 10000)) / 100) - 10;
	    iyc = istrk - (istyp * 10000) - ((ixc + 10) * 100) - 11;
	    xc = (float) (ixc) * propotion;
	    if (font == 2 || font == 3)
		xc = xc + (6. / 21.) * (float) iyc;	/* Oblique font */
	    yc = (float) iyc;
	    xc = xc * csize;
	    yc = yc * csize;
	    xct = xc * cosin - yc * sine;
	    yct = xc * sine + yc * cosin;
	    xct += sxloc;
	    yct += syloc;
	    /*
	     * stroke type 1 - move stroke type 2 - draw stroke
	     * type 3 - last move stroke type 0 - last draw
	     */
	    npen = 3;
	    if (istyp == 2 || istyp == 0)
		npen = 2;

	    if (npen == 2) {
		img_line(iwin, x1, y1, xct, yct);
		x1 = xct;
		y1 = yct;
	    } else if (npen == 3) {
		x1 = xct;
		y1 = yct;
	    }
	    icndx++;
	}
	while (istyp == 1 || istyp == 2);
	sxloc = xct;
	syloc = yct;
    }
}

void xy2ixiy(x, y, ix, iy)
float x, y;
int *ix, *iy;
{
    *ix = scale * (x + orgX);
    *iy = height - scale * (y + orgY);
}
