/*
 * 2002/11/22 HAVE_GH
 *            FC_G77
 */

/*
 * =======================================================================
 * 
 * PURPOSE: GRAPHIC ROUTINE FOR  X/PS/PNG/JPG 
 * Hiroshi TSURUOKA / All Rights Reserved.
 * 
 * =======================================================================
 * FUNCTION LIST 
 * pc_plotinit(iwin,winname,x0,y0,xsize,ysize,scale)
 * pc_plotend(iwin,end) 
 * pc_pscode(iwin,color_mode) 
 * pc_clear(iwin)
 * pc_cleararea(iwin,x1,y1,x2,y2) 
 * pc_line(iwin,x1,y1,x2,y2)
 * pc_plot(iwin,x,y,n) 
 * pc_symbol(iwin,x,y,size,symbol,outline)
 * pc_circle(iwin,x,y,size,outline)
 * pc_arc(iwin,x,y,radius,angle1,angle2,outline)
 * pc_square(iwin,x,y,size,outline) 
 * pc_plus(iwin,x,y,size,outline)
 * pc_times(iwin,x,y,size,outline) 
 * pc_rect(iwin,x1,y1,wx,wy,outline)
 * pc_roundbox(iwin,x0,y0,wx,wy,outline)
 * pc_roundrect(iwin,x0,y0,wx,wy,outline) 
 * pc_triangle(iwin,x,y,size,outline)
 * pc_triangle1(iwin,x,y,size,outline) 
 * pc_triangle2(iwin,x,y,size,outline)
 * pc_triangle3(iwin,x,y,size,outline) 
 * pc_diamond(iwin,x,y,size,outline)
 * pc_polygon(iwin,x,y,n,outline)
 * pc_imagefill(iwin,x,y,n,image_no,invert,outline) 
 * pc_mouse (iwin,itype,m,x,y) 
 * pc_setcolor(iwin,r,g,b) 
 * pc_alloccolor(iwin,no,r,g,b)
 * pc_setqbcolor(iwin,color) 
 * pc_setline(iwin,linewidth)
 * pc_setdash(iwin,itype) 
 * pc_setbkcolor(iwin,r,g,b) 
 * pc_setfont(iwin,font_no)
 * pc_setgrayshade(iwin,grayshade)
 * pc_text2(iwin,x0,y0,size,text,angle,ntext,ipos)
 * pc_text(iwin,xin,yin,size,text,angle,ntext,ipos) 
 * pc_rescale(iwin,rescale)
 * pc_string(iwin,xin,yin,size,text,angle,ntext,ipos) 
 * pc_rescale(iwin,rescale)
 * pc_resize(iwin,width,height) 
 * pc_raise(iwin) 
 * pc_bell(iwin,percent)
 * pc_vector(iwin,x,y,direction,length,aw,hl,hw,outline)
 * pc_tranalate(iwin,dx,dy) 
 * pc_moveto(iwin,x,y) 
 * pc_lineto(iwin,x,y)
 * pc_rlineto(iwin,dx,dy)
 * pc_setlayer(iwin,layer)
 * pc_viewlayer(iwin,layer)
 * pc_copylayer(iwin,layer1,layer2)
 * 
 */

#include <stdio.h>
#include <math.h>
#include <memory.h>

void pc_plotinit();
void pc_plotend();
void pc_pscode();
void pc_clear();
void pc_cleararea();
void pc_line();
void pc_plot();
void pc_symbol();
void pc_circle();
void pc_arc();
void pc_square();
void pc_plus();
void pc_times();
void pc_rect();
void pc_triangle();
void pc_triangle1();
void pc_triangle2();
void pc_triangle3();
void pc_diamond();
void pc_polygon();
void pc_imagefill();
void pc_mouse();
void pc_setcolor();
void pc_alloccolor();
void pc_setqbcolor();
void pc_setline();
void pc_setdash();
void pc_setbkcolor();
void pc_setfont();
void pc_setgrayshade();
void pc_text2();
void pc_text();
void pc_rescale();
void pc_resize();
void pc_raise();
void pc_roundbox();
void pc_roundrect();
void pc_bell();
void pc_vector();
void pc_translate();
void pc_moveto();
void pc_lineto();
void pc_rlineto();
void pc_flush();
void pc_setlayer();
void pc_viewlayer();
void pc_copylayer();

#ifdef FC_G77
#define pc_plotinit_ pc_plotinit__
#define pc_plotend_ pc_plotend__
#define pc_pscode_ pc_pscode__
#define pc_clear_ pc_clear__
#define pc_cleararea_ pc_cleararea__
#define pc_line_ pc_line__
#define pc_vector_ pc_vector__
#define pc_plot_ pc_plot__
#define pc_symbol_ pc_symbol__
#define pc_circle_ pc_circle__
#define pc_arc_ pc_arc__
#define pc_square_ pc_square__
#define pc_plus_ pc_plus__
#define pc_times_ pc_times__
#define pc_rect_ pc_rect__
#define pc_roundbox_ pc_roundbox__
#define pc_roundrect_ pc_roundrect__
#define pc_triangle_ pc_triangle__
#define pc_triangle1_ pc_triangle1__
#define pc_triangle2_ pc_triangle2__
#define pc_triangle3_ pc_triangle3__
#define pc_diamond_ pc_diamond__
#define pc_polygon_ pc_polygon__
#define pc_imagefill_ pc_imagefill__
#define pc_mouse_ pc_mouse__
#define pc_setcolor_ pc_setcolor__
#define pc_alloccolor_ pc_alloccolor__
#define pc_setqbcolor_ pc_setqbcolor__
#define pc_setline_ pc_setline__
#define pc_setdash_ pc_setdash__
#define pc_setbkcolor_ pc_setbkcolor__
#define pc_setfont_ pc_setfont__
#define pc_setgrayshade_ pc_setgrayshade__
#define pc_text2_ pc_text2__
#define pc_text_ pc_text__
#define pc_string_ pc_string__
#define pc_rescale_ pc_rescale__
#define pc_resize_ pc_resize__
#define pc_raise_ pc_raise__
#define pc_bell_ pc_bell__
#define pc_translate_ pc_translate__
#define pc_moveto_ pc_moveto__
#define pc_lineto_ pc_lineto__
#define pc_rlineto_ pc_rlineto__
#define pc_flush_ pc_flush__
#define pc_setlayer_ pc_setlayer__
#define pc_viewlayer_ pc_viewlayer__
#define pc_copylayer_ pc_copylayer__
#endif

static int font = 0;
static int ps_color = 0;

#define PS 10
#define PNG 11
#define JPG 12
#define TEXT2 999.0

void pc_plotinit(iwin, winname, x0, y0, xsize, ysize, scale)
int iwin;
char *winname;
float x0, y0, xsize, ysize, scale;
{
    if (iwin == PS)
	psmm_plotinit(winname, xsize, ysize);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_plotinit(iwin, winname, x0, y0, xsize, ysize, scale);
#endif
    else 
	xwin_plotinit(iwin, winname, x0, y0, xsize, ysize, scale);
}

/* fortran interface */
int pc_plotinit_(iwin, winname, x0, y0, xsize, ysize, scale)
int *iwin;
char *winname;
float *x0, *y0, *xsize, *ysize, *scale;
{
    pc_plotinit(*iwin, winname, *x0, *y0, *xsize, *ysize, *scale);
}

void pc_plotend(iwin, end)
int iwin;
int end;
{
    if (iwin == PS)
	psmm_plotend(end);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_plotend(iwin, end);
#endif
    else {
	if (end == 0) {
	    printf("---  enter reurn key to close window ---\n");
	    getchar();
	}
	xwin_plotend(iwin);
    }
}

/* fortran interface */
int pc_plotend_(iwin, end)
int *iwin;
int *end;
{
    pc_plotend(*iwin, *end);
}

void pc_pscode(iwin, pscode)
int iwin;
int pscode;
{
    /* PS only */
    if (iwin == PS) {
	psmm_pscode(pscode);
	ps_color = pscode;
    }
}

/* fortran interface */
int pc_pscode_(iwin, pscode)
int *iwin;
int *pscode;
{
    pc_pscode(*iwin, *pscode);
}

void pc_clear(iwin)
int iwin;
{
    /* X only */
    if (iwin < PS)
	xwin_clear(iwin);
}

/* fortran interface */
int pc_clear_(iwin)
int *iwin;
{
    pc_clear(*iwin);
}

void pc_cleararea(iwin, x1, y1, x2, y2)
int iwin;
float x1, y1, x2, y2;
{
    /* X only */
    if (iwin < PS)
	xwin_cleararea(iwin, x1, y1, x2, y2);
}

/* fortran interface */
int pc_cleararea_(iwin, x1, y1, x2, y2)
int *iwin;
float *x1, *y1, *x2, *y2;
{
    pc_cleararea(*iwin, *x1, *y1, *x2, *y2);
}

void pc_line(iwin, x1, y1, x2, y2)
int iwin;
float x1, y1, x2, y2;
{
    if (iwin == PS)
	psmm_line(x1, y1, x2, y2);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_line(iwin, x1, y1, x2, y2);
#endif
    else
	xwin_line(iwin, x1, y1, x2, y2);
}

/* fortran interface */
int pc_line_(iwin, x1, y1, x2, y2)
int *iwin;
float *x1, *y1, *x2, *y2;
{
    pc_line(*iwin, *x1, *y1, *x2, *y2);
}

void pc_vector(iwin, x, y, direction, length, aw, hl, hw, outline)
int iwin;
float x, y, direction, length;
float aw, hl, hw;
int outline;
{
    int i;
    float xx[8], yy[8], rad;
    rad = 3.14159 / 180.;
    if (iwin == PS)
	psmm_vector(x, y, direction, length, aw / 25.4, hl / 25.4, hw / 50.8, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_vector(iwin, x, y, direction, length, aw, hl, hw, outline);
#endif
    else {
	hw = 1.5 * hw;
	xx[0] = x + 0.5 * aw * cos(rad * (direction + 90.));
	yy[0] = y + 0.5 * aw * sin(rad * (direction + 90.));
	xx[1] = xx[0] + (length - hl) * cos(rad * direction);
	yy[1] = yy[0] + (length - hl) * sin(rad * direction);
	xx[2] = xx[1] + (hw - aw) / 2. * cos(rad * (direction + 90.));
	yy[2] = yy[1] + (hw - aw) / 2. * sin(rad * (direction + 90.));
	xx[3] = x + length * cos(rad * direction);
	yy[3] = y + length * sin(rad * direction);
	xx[4] = x + (length - hl) * cos(rad * direction) + 0.5 * (hw - aw) * cos(rad * (direction - 90.));
	yy[4] = y + (length - hl) * sin(rad * direction) + 0.5 * (hw - aw) * sin(rad * (direction - 90.));
	xx[5] = x + (length - hl) * cos(rad * direction) + 0.5 * aw * cos(rad * (direction - 90.));
	yy[5] = y + (length - hl) * sin(rad * direction) + 0.5 * aw * sin(rad * (direction - 90.));
	xx[6] = x + 0.5 * aw * cos(rad * (direction - 90.));
	yy[6] = y + 0.5 * aw * sin(rad * (direction - 90.));
	xwin_polygon(iwin, xx, yy, 7, outline);
    }
}

/* fortran interface */
int pc_vector_(iwin, x, y, direction, length, aw, hl, hw, outline)
int *iwin;
float *x, *y, *direction, *length;
float *aw, *hl, *hw;
int *outline;
{
    pc_vector(*iwin, *x, *y, *direction, *length, *aw, *hl, *hw, *outline);
}

void pc_plot(iwin, x, y, n)
int iwin;
float x[], y[];
int n;
{
    int i;
    if (iwin == PS)
	psmm_plot(x, y, n);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_plot(iwin, x, y, n);
#endif
    else
	xwin_lines(iwin, x, y, n);
}

/* fortran interface */
int pc_plot_(iwin, x, y, n)
int *iwin;
float x[], y[];
int *n;
{
    pc_plot(*iwin, x, y, *n);
}

void pc_symbol(iwin, x, y, size, symbol, outline)
int iwin;
float x, y, size;
int symbol;
int outline;
{
    float rr;
    if (iwin == PS) {
	rr = size;
	if (symbol == 1)
	    rr = 0.5 * size;
	if (symbol == 5)
	    rr = size / sqrt(2.);
	psmm_symbol(x, y, rr, symbol, outline);
    }
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG) {
	img_symbol(iwin, x, y, size, symbol, outline);
    }
#endif
    else {
	if (symbol == 1)
	    pc_circle(iwin, x, y, size / 2., outline);
	else if (symbol == 2)
	    pc_square(iwin, x, y, size, outline);
	else if (symbol == 3)
	    pc_plus(iwin, x, y, size, outline);
	else if (symbol == 4)
	    pc_triangle(iwin, x, y, size, outline);
	else if (symbol == 5)
	    pc_diamond(iwin, x, y, size / sqrt(2.0), outline);
	else if (symbol == 6)
	    pc_triangle1(iwin, x, y, size, outline);
	else if (symbol == 7)
	    pc_triangle2(iwin, x, y, size, outline);
	else if (symbol == 8)
	    pc_triangle3(iwin, x, y, size, outline);
	else if (symbol == 9)
	    pc_times(iwin, x, y, size, outline);
    }
}

/* fortran interface */
int pc_symbol_(iwin, x, y, size, symbol, outline)
int *iwin;
float *x, *y, *size;
int *symbol;
int *outline;
{
    pc_symbol(*iwin, *x, *y, *size, *symbol, *outline);
}

void pc_circle(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float x1, y1, r2;
    if (iwin == PS)
	psmm_circle(x, y, size, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_circle(iwin, x, y, size, outline);
#endif
    else {
	x1 = x - size;
	y1 = y + size;
	r2 = 2. * size;
	xwin_circle(iwin, x1, y1, r2, outline);
    }
}

/* fortran interface */
int pc_circle_(iwin, x, y, size, outline)
int *iwin;
float *x, *y, *size;
int *outline;
{
    pc_circle(*iwin, *x, *y, *size, *outline);
}

void pc_arc(iwin, x, y, radius, angle1, angle2, outline)
int iwin;
float x, y, radius;
int angle1, angle2, outline;
{
    float x1, y1, r2;
    if (iwin == PS)
	psmm_arc(x, y, radius, angle1, angle2, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG);
#endif
    else {
	x1 = x - radius;
	y1 = y + radius;
	r2 = 2. * radius;
	xwin_arc(iwin, x1, y1, r2, r2, angle1, angle2, outline);
    }
}

/* fortran interface */
int pc_arc_(iwin, x, y, radius, angle1, angle2, outline)
int *iwin;
float *x, *y, *radius;
int *angle1, *angle2, *outline;
{
    pc_arc(*iwin, *x, *y, *radius, *angle1, *angle2, *outline);
}

void pc_square(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float x1, y1;
    if (iwin == PS)
	psmm_square(x, y, size, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_square(iwin, x, y, size, outline);
#endif
    else {
	x1 = x - 0.5 * size;
	y1 = y + 0.5 * size;
	xwin_squa(iwin, x1, y1, size, outline);
    }
}

/* fortran interface */
int pc_square_(iwin, x, y, size, outline)
int *iwin;
float *x, *y, *size;
int *outline;
{
    pc_square(*iwin, *x, *y, *size, *outline);
}


void pc_plus(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float x1, y1, x2, y2;
    if (iwin == PS)
	psmm_plus(x, y, size, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_plus(iwin, x, y, size, outline);
#endif
    else {
	x1 = x - 0.5 * size;
	y1 = y - 0.5 * size;
	x2 = x + 0.5 * size;
	y2 = y + 0.5 * size;
	xwin_line(iwin, x1, y, x2, y);
	xwin_line(iwin, x, y1, x, y2);
    }
}

/* fortran interface */
int pc_plus_(iwin, x, y, size, outline)
int *iwin;
float *x, *y, *size;
int *outline;
{
    pc_plus(*iwin, *x, *y, *size, *outline);
}


void pc_times(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float x1, y1, x2, y2;
    if (iwin == PS)
	psmm_times(x, y, size, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_times(iwin, x, y, size, outline);
#endif
    else {
	x1 = x - 0.5 * size;
	y1 = y - 0.5 * size;
	x2 = x + 0.5 * size;
	y2 = y + 0.5 * size;
	xwin_line(iwin, x1, y1, x2, y2);
	xwin_line(iwin, x1, y2, x2, y1);
    }
}

/* fortran interface */
int pc_times_(iwin, x, y, size, outline)
int *iwin;
float *x, *y, *size;
int *outline;
{
    pc_times(*iwin, *x, *y, *size, *outline);
}


void pc_rect(iwin, x1, y1, wx, wy, outline)
int iwin;
float x1, y1, wx, wy;
int outline;
{
    float px[4], py[4];
    if (iwin == PS)
	psmm_rect(x1, y1, wx, wy, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_rect(iwin, x1, y1, wx, wy, outline);
#endif
    else {
	px[0] = x1;
	py[0] = y1;
	px[1] = x1 + wx;
	py[1] = y1;
	px[2] = x1 + wx;
	py[2] = y1 + wy;
	px[3] = x1;
	py[3] = y1 + wy;
	xwin_polygon(iwin, px, py, 4, outline);
    }
}

/* fortran interface */
int pc_rect_(iwin, x1, y1, wx, wy, outline)
int *iwin;
float *x1, *y1, *wx, *wy;
int *outline;
{
    pc_rect(*iwin, *x1, *y1, *wx, *wy, *outline);
}

void pc_roundbox(iwin, x0, y0, wx, wy, outline)
int iwin;
float x0, y0, wx, wy;
int outline;
{
    /* X only */
    if (iwin < PS) {
	float xc1, xc2, yc, width;
	xc1 = x0 + wy / 2.;
	xc2 = xc1 + wx - wy;
	yc = y0 + wy / 2.;
	width = wx - wy;
	if (outline == 0) {
	    pc_arc(iwin, xc1, yc, wy / 2., 90, 270, 0);
	    pc_rect(iwin, xc1 - 0.5, y0, width + 1.0, wy, 0);
	    pc_arc(iwin, xc2, yc, wy / 2., -90, 90, 0);
	} else {
	    pc_arc(iwin, xc1, yc, wy / 2., 90, 270, 1);
	    pc_line(iwin, xc1, y0, xc2, y0);
	    pc_arc(iwin, xc2, yc, wy / 2., -90, 90, 1);
	    pc_line(iwin, xc2, y0 + wy, xc1, y0 + wy);
	}
    }
}

/* fortran interface */
int pc_roundbox_(iwin, x0, y0, wx, wy, outline)
int *iwin;
float *x0, *y0, *wx, *wy;
int *outline;
{
    pc_roundbox(*iwin, *x0, *y0, *wx, *wy, *outline);
}

void pc_roundrect(iwin, x0, y0, wx, wy, outline)
int iwin;
float x0, y0, wx, wy;
int outline;
{
    float x1, x2, y1, y2, r = 3.;
    float wx2, wy2;
    /* X only */
    if (iwin < PS) {
	x1 = x0 + r - 0.4;
	y1 = y0 + r - 0.4;
	x2 = x0 + wx - r;
	y2 = y0 + wy - r;
	wx2 = wx - 2. * r + 0.8;
	wy2 = wy - 2. * r + 0.8;
	if (wx2 < 0)
	    wx2 = 0.1;
	if (wy2 < 0)
	    wy2 = 0.1;
	if (outline == 0) {
	    pc_rect(iwin, x1, y0, wx2, wy, 0);
	    pc_rect(iwin, x2, y1, r, wy2, 0);
	    pc_rect(iwin, x0, y1, r, wy2, 0);
	    pc_arc(iwin, x0 + r, y0 + r, r, 180, 270, 0);
	    pc_arc(iwin, x0 + wx - r, y0 + r, r, -90, 0, 0);
	    pc_arc(iwin, x0 + wx - r, y0 + wy - r, r, 0, 90, 0);
	    pc_arc(iwin, x0 + r, y0 + wy - r, r, 90, 180, 0);
	} else {
	    pc_arc(iwin, x0 + r, y0 + r, r, 180, 270, 1);
	    pc_line(iwin, x0 + r, y0, x0 + wx - r, y0);
	    pc_arc(iwin, x0 + wx - r, y0 + r, r, -90, 0, 1);
	    pc_line(iwin, x0 + wx, y0 + r, x0 + wx, y0 + wy - r);
	    pc_arc(iwin, x0 + wx - r, y0 + wy - r, r, 0, 90, 1);
	    pc_line(iwin, x0 + wx - r, y0 + wy, x0 + r, y0 + wy);
	    pc_arc(iwin, x0 + r, y0 + wy - r, r, 90, 180, 1);
	    pc_line(iwin, x0, y0 + wy - r, x0, y0 + r);
	}
    }
}

/* fortran interface */
int pc_roundrect_(iwin, x0, y0, wx, wy, outline)
int *iwin;
float *x0, *y0, *wx, *wy;
int *outline;
{
    pc_roundrect(*iwin, *x0, *y0, *wx, *wy, *outline);
}

void pc_triangle(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float px[3], py[3];
    if (iwin == PS)
	psmm_triangle(x, y, size, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_triangle(iwin, x, y, size, outline);
#endif
    else {
	px[0] = x;
	py[0] = y + 0.57736 * size;
	px[1] = x - 0.5 * size;
	py[1] = y - 0.28867 * size;
	px[2] = x + 0.5 * size;
	py[2] = y - 0.28867 * size;
	xwin_polygon(iwin, px, py, 3, outline);
    }
}

/* fortran interface */
int pc_triangle_(iwin, x, y, size, outline)
int *iwin;
float *x, *y, *size;
int *outline;
{
    pc_triangle(*iwin, *x, *y, *size, *outline);
}


void pc_triangle1(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float px[3], py[3];
    if (iwin == PS)
	psmm_triangle(x, y, size, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_triangle1(iwin, x, y, size, outline);
#endif
    else {
	px[0] = x - 0.57736 * size;
	py[0] = y;
	px[1] = x + 0.28867 * size;
	py[1] = y - 0.5 * size;
	px[2] = px[1];
	py[2] = y + 0.5 * size;
	xwin_polygon(iwin, px, py, 3, outline);
    }
}

/* fortran interface */
int pc_triangle1_(iwin, x, y, size, outline)
int *iwin;
float *x, *y, *size;
int *outline;
{
    pc_triangle1(*iwin, *x, *y, *size, *outline);
}


void pc_triangle2(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float px[3], py[3];
    if (iwin == PS)
	psmm_triangle(x, y, size, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_triangle2(iwin, x, y, size, outline);
#endif
    else {
	px[0] = x - 0.5 * size;
	py[0] = y + 0.28867 * size;
	px[1] = x;
	py[1] = y - 0.57736 * size;
	px[2] = x + 0.5 * size;
	py[2] = py[0];
	xwin_polygon(iwin, px, py, 3, outline);
    }
}

/* fortran interface */
int pc_triangle2_(iwin, x, y, size, outline)
int *iwin;
float *x, *y, *size;
int *outline;
{
    pc_triangle2(*iwin, *x, *y, *size, *outline);
}



void pc_triangle3(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float px[3], py[3];
    if (iwin == PS)
	psmm_triangle(x, y, size, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_triangle3(iwin, x, y, size, outline);
#endif
    else {
	px[0] = x + 0.57736 * size;
	py[0] = y;
	px[1] = x - 0.28867 * size;
	py[1] = y - 0.5 * size;
	px[2] = px[1];
	py[2] = y + 0.5 * size;
	xwin_polygon(iwin, px, py, 3, outline);
    }
}

/* fortran interface */
int pc_triangle3_(iwin, x, y, size, outline)
int *iwin;
float *x, *y, *size;
int *outline;
{
    pc_triangle3(*iwin, *x, *y, *size, *outline);
}


void pc_diamond(iwin, x, y, size, outline)
int iwin;
float x, y, size;
int outline;
{
    float px[4], py[4];
    if (iwin == PS)
	psmm_diamond(x, y, size, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_diamond(iwin, x, y, size, outline);
#endif
    else {
	px[0] = x;
	py[0] = y + 0.7071 * size;
	px[1] = x - 0.7071 * size;
	py[1] = y;
	px[2] = x;
	py[2] = y - 0.7071 * size;
	px[3] = x + 0.7071 * size;
	py[3] = y;
	xwin_polygon(iwin, px, py, 4, outline);
    }
}

/* fortran interface */
int pc_diamond_(iwin, x, y, size, outline)
int *iwin;
float *x, *y, *size;
int *outline;
{
    pc_diamond(*iwin, *x, *y, *size, *outline);
}


void pc_polygon(iwin, x, y, n, outline)
int iwin;
float x[], y[];
int n;
int outline;
{
    if (iwin == PS)
	psmm_polygon(x, y, n, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_polygon(iwin, x, y, n, outline);
#endif
    else
	xwin_polygon(iwin, x, y, n, outline);
}

/* fortran interface */
int pc_polygon_(iwin, x, y, n, outline)
int *iwin;
float x[], y[];
int *n;
int *outline;
{
    pc_polygon(*iwin, x, y, *n, *outline);
}

void pc_imagefill(iwin, x, y, n, image_no, invert, outline)
int iwin;
float x[], y[];
int n;
int image_no;
int invert;
int outline;
{
    if (iwin == PS)
	psmm_imagefill(x, y, n, image_no, invert, outline);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_polygon(iwin, x, y, n, outline);
#endif
    else
	xwin_polygon(iwin, x, y, n, outline);
}

/* fortran interface */
int pc_imagefill_(iwin, x, y, n, image_no, invert, outline)
int *iwin;
float x[], y[];
int *n;
int *image_no;
int *invert;
int *outline;
{
    pc_imagefill(*iwin, x, y, *n, *image_no, *invert, *outline);
}


void pc_mouse(iwin, itype, m, x, y)
int iwin;
int itype;
int *m;
float *x, *y;
/*
 * itype 0: crosshasr 1: + 2: arrow m		(o) number of button pressed
 * 1: Left Button 2: Middle Buton 3: Right Button x,y
 */
{
    /* X only */
    if (iwin < PS)
	xwin_mouse(iwin, itype, m, x, y);
}

/* fortran interface */
int pc_mouse_(iwin, itype, m, x, y)
int *iwin;
int *itype;
int *m;
float *x, *y;
{
    pc_mouse(*iwin, *itype, m, x, y);
}

void pc_setcolor(iwin, r, g, b)
int iwin;
int r, g, b;
{
    if (iwin == PS) {
	if (ps_color)
	    psmm_setcolor(r, g, b);
    }
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG) {
	img_setcolor(iwin, r, g, b);
    }
#endif
    else {
	xwin_setcolor(iwin, r, g, b);
    }
}

/* fortran interface */
int pc_setcolor_(iwin, r, g, b)
int *iwin;
int *r, *g, *b;
{
    pc_setcolor(*iwin, *r, *g, *b);
}

void pc_alloccolor(iwin, no, r, g, b)
int iwin;
int no, r, g, b;
{
    if (iwin == PS) {
	if (ps_color)
	    psmm_alloccolor(no, r, g, b);
    }
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG) {
	img_alloccolor(iwin, no, r, g, b);
    }
#endif
    else {
	xwin_alloccolor(iwin, no, r, g, b);
    }
}

/* fortran interface */
int pc_alloccolor_(iwin, no, r, g, b)
int *iwin;
int *no, *r, *g, *b;
{
    pc_alloccolor(*iwin, *no, *r, *g, *b);
}

void pc_setqbcolor(iwin, color)
int iwin;
int color;
{
    if (iwin == PS) {
	if (ps_color)
	    psmm_setqbcolor(color);
    }
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG) {
	img_setqbcolor(iwin, color);
    }
#endif
    else {
	xwin_setqbcolor(iwin, color);
    }
}

/* fortran interface */
int pc_setqbcolor_(iwin, color)
int *iwin;
int *color;
{
    pc_setqbcolor(*iwin, *color);
}

void pc_setline(iwin, linewidth)
int iwin;
int linewidth;
{
    int width;
    if (iwin == PS)
	psmm_setline(linewidth);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_setline(iwin, linewidth);
#endif
    else {
	width = linewidth / 2;
	xwin_setline(iwin, width);
    }
}

/* fortran interface */
int pc_setline_(iwin, linewidth)
int *iwin;
int *linewidth;
{
    pc_setline(*iwin, *linewidth);
}


void pc_setdash(iwin, itype)
int iwin;
int itype;
/*
 * Set Line Dash itype:1 ------------- 
                       2 . . . . . . .  
                       3 - - - - - - -
 */
{
    if (iwin == PS)
	psmm_setdash(itype);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_setdash(iwin, itype);
#endif
    else
	xwin_setdash(iwin, itype);
}

/* fortran interface */
int pc_setdash_(iwin, itype)
int *iwin;
int *itype;
{
    pc_setdash(*iwin, *itype);
}


void pc_setbkcolor(iwin, r, g, b)
int iwin;
int r, g, b;
{
    if (iwin == PS)
	psmm_setbkcolor(r, g, b);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_setbkcolor(iwin, r, g, b);
#endif
    else
	xwin_setbkcolor(iwin, r, g, b);
}

/* fortran interface */
int pc_setbkcolor_(iwin, r, g, b)
int *iwin;
int *r, *g, *b;
{
    pc_setbkcolor(*iwin, *r, *g, *b);
}


void pc_setfont(iwin, font_no)
int iwin;
int font_no;
{
    /*
     * font_no = 0   regular = 1   bold = 2   italic = 3   bold italic
     */
    if (iwin == PS)
	psmm_setfont(font_no);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_setfont(iwin, font_no);
#endif
    else
	font = font_no;
}

/* fortran interface */
int pc_setfont_(iwin, font_no)
int *iwin;
int *font_no;
{
    pc_setfont(*iwin, *font_no);
}


void pc_setgrayshade(iwin, grayshade)
int iwin;
int grayshade;
{
    if (iwin == PS)
	psmm_setgrayshade(grayshade);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_setgrayshade(iwin, grayshade);
#endif
    else;
}

/* fortran interface */
int pc_setgrayshade_(iwin, grayshade)
int *iwin;
int *grayshade;
{
    pc_setgrayshade(*iwin, *grayshade);
}


void pc_text2(iwin, x0, y0, size, text, angle, ntext, ipos)
int iwin;
float x0, y0, size, angle;
char *text;
int ntext;
int ipos;
{
    float x, y;
    int ixpos, div;
    if (iwin == PS)
	psmm_text(x0, y0, size, text, angle, ntext, ipos);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_text(iwin, x0, y0, size, text, angle, ntext, ipos);
#endif
    else {
	x = x0;
	if (ipos == 1)
	    y = y0;
	else if (ipos == 2)
	    y = y0;
	else if (ipos == 3)
	    y = y0;
	else if (ipos == 4)
	    y = y0 - size / 2.;
	else if (ipos == 5)
	    y = y0 - size / 2.;
	else if (ipos == 6)
	    y = y0 - size / 2.;
	else if (ipos == 7)
	    y = y0 - size;
	else if (ipos == 8)
	    y = y0 - size;
	else if (ipos == 9)
	    y = y0 - size;
	div = 3;
	ixpos = ipos % div;
	if (ixpos == 0)
	    ixpos = 3;
	xwin_text2(iwin, x, y, size, text, ntext, font, ixpos);
    }
}

/* fortran interface */
int pc_text2_(iwin, x0, y0, size, text, angle, ntext, ipos)
int *iwin;
float *x0, *y0, *size, *angle;
char *text;
int *ntext;
int *ipos;
{
    pc_text2(*iwin, *x0, *y0, *size, text, *angle, *ntext, *ipos);
}

void pc_text(iwin, xin, yin, size, text, angle, ntext, ipos)
int iwin;
float xin, yin, size, angle;
char *text;
int ntext;
int ipos;
{
    if (iwin == PS)
	psmm_text(xin, yin, size, text, angle, ntext, ipos);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_text(iwin, xin, yin, size, text, angle, ntext, ipos);
#endif
    else {
	if (angle == TEXT2) {
	    xwin_text2(iwin, xin, yin, size, text, ntext, font, ipos);
	} else {
	    xwin_text(iwin, xin, yin, size, text, angle, ntext, font, ipos);
	}
    }
}

/* fortran interface */
int pc_text_(iwin, x0, y0, size, text, angle, ntext, ipos)
int *iwin;
float *x0, *y0, *size, *angle;
char *text;
int *ntext;
int *ipos;
{
    pc_text(*iwin, *x0, *y0, *size, text, *angle, *ntext, *ipos);
}

void pc_string(iwin, xin, yin, size, text, angle, ntext, ipos)
int iwin, size;
float xin, yin, angle;
char *text;
int ntext;
int ipos;
{
    float fsize;
    switch (size) {
    case -2:
	fsize = 8.0 * 25.4 / 72.0;
	break;
    case -1:
	fsize = 10.0 * 25.4 / 72.0;
	break;
    case 0:
	fsize = 12.0 * 25.4 / 72.0;
	break;
    case 1:
	fsize = 14.0 * 25.4 / 72.0;
	break;
    case 2:
	fsize = 16.0 * 25.4 / 72.0;
	break;
    }

    if (iwin == PS)
	psmm_text(xin, yin, fsize, text, angle, ntext, ipos);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_string(iwin, xin, yin, size, text, angle, ntext, ipos);
#endif
    else {
	if (angle == TEXT2) {
	    xwin_text2(iwin, xin, yin, fsize, text, ntext, font, ipos);
	} else {
	    xwin_text(iwin, xin, yin, fsize, text, angle, ntext, font, ipos);
	}
    }
}

/* fortran interface */
int pc_string_(iwin, x0, y0, size, text, angle, ntext, ipos)
int *iwin, *size;
float *x0, *y0, *angle;
char *text;
int *ntext;
int *ipos;
{
    pc_string(*iwin, *x0, *y0, *size, text, *angle, *ntext, *ipos);
}

void pc_rescale(iwin, rescale)
int iwin, rescale;
{
    /* X only */
    if (iwin < PS)
	xwin_rescale(iwin, rescale);
}

/* fortran interface */
int pc_rescale_(iwin, rescale)
int *iwin, *rescale;
{
    pc_rescale(*iwin, *rescale);
}

void pc_resize(iwin, width, height)
int iwin;
float width, height;
{
    /* X only */
    if (iwin < PS)
	xwin_resize(iwin, width, height);
}

/* fortran interface */
int pc_resize_(iwin, width, height)
int *iwin;
float *width, *height;
{
    pc_resize(*iwin, *width, *height);
}


void pc_raise(iwin)
int iwin;
{
    /* X only */
    if (iwin < PS)
	xwin_raise(iwin);
}

/* fortran interface */
int pc_raise_(iwin)
int *iwin;
{
    pc_raise(*iwin);
}

void pc_bell(iwin, percent)
int iwin;
int percent;
{
    /* X only */
    if (iwin < PS)
	xwin_bell(iwin, percent);
}

/* fortran interface */
int pc_bell_(iwin, percent)
int *iwin;
int *percent;
{
    pc_bell(*iwin, *percent);
}

void pc_translate(iwin, x, y)
int iwin;
float x, y;
{
    if (iwin == PS)
	psmm_translate(x, y);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_translate(iwin, x, y);
#endif
    else
	xwin_translate(iwin, x, y);
}

/* fortran interface */
int pc_translate_(iwin, x, y)
int *iwin;
float *x, *y;
{
    pc_translate(*iwin, *x, *y);
}

void pc_moveto(iwin, x, y)
int iwin;
float x, y;
{
    if (iwin == PS)
	psmm_moveto(x, y);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_moveto(iwin, x, y);
#endif
    else
	xwin_moveto(iwin, x, y);
}

/* fortran interface */
int pc_moveto_(iwin, x, y)
int *iwin;
float *x, *y;
{
    pc_moveto(*iwin, *x, *y);
}

void pc_lineto(iwin, x, y)
int iwin;
float x, y;
{
    if (iwin == PS)
	psmm_lineto(x, y);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_lineto(iwin, x, y);
#endif
    else
	xwin_lineto(iwin, x, y);
}

/* fortran interface */
int pc_lineto_(iwin, x, y)
int *iwin;
float *x, *y;
{
    pc_lineto(*iwin, *x, *y);
}

void pc_rlineto(iwin, dx, dy)
int iwin;
float dx, dy;
{
    if (iwin == PS)
	psmm_rlineto(dx, dy);
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	img_rlineto(iwin, dx, dy);
#endif
    else
	xwin_rlineto(iwin, dx, dy);
}

/* fortran interface */
int pc_rlineto_(iwin, dx, dy)
int *iwin;
float *dx, *dy;
{
    pc_rlineto(*iwin, *dx, *dy);
}

void pc_flush(iwin)
int iwin;
{
    if (iwin == PS)
	;
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	;
#endif
    else
	xwin_flush(iwin);
}

/* fortran interface */
int pc_flush_(iwin)
int *iwin;
{
    pc_flush(*iwin);
}

void pc_setlayer(iwin,layer)
int iwin,layer;
{
    if (iwin == PS)
	;
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	;
#endif
    else
	xwin_setlayer(iwin,layer);
}

/* fortran interface */
int pc_setlayer_(iwin,layer)
int *iwin, *layer;
{
    pc_setlayer(*iwin,*layer);
}

void pc_viewlayer(iwin,layer)
int iwin,layer;
{
    if (iwin == PS)
	;
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	;
#endif
    else
	xwin_viewlayer(iwin,layer);
}

/* fortran interface */
int pc_viewlayer_(iwin,layer)
int *iwin, *layer;
{
    pc_viewlayer(*iwin,*layer);
}

void pc_copylayer(iwin,layer1,layer2)
int iwin,layer1,layer2;
{
    if (iwin == PS)
	;
#ifdef HAVE_GD
    else if (iwin == PNG || iwin == JPG)
	;
#endif
    else
	xwin_copylayer(iwin,layer1,layer2);
}

/* fortran interface */
int pc_copylayer_(iwin,layer1,layer2)
int *iwin, *layer1, *layer2;
{
    pc_copylayer(*iwin,*layer1,*layer2);
}
