c=======================================================================      
      subroutine dataminmax(data,n,datamin,datamax)
c=======================================================================
c PURPOSE: To Get for DATA Minumum,Maxmimum 
c=======================================================================
c INPUT ARGUMENUS:
c     data(n): DATA
c     n      : DATA NUMBER
c=======================================================================
c OUTPUT ARGUMENUS:
c     datamin: DATA MINIMUM
c     datamax: DATA MAXIMUM
c=======================================================================
c MODIFICATION HISTORY
c     AUG 26, 1994 ORIGINAL VERSION
c=======================================================================
      dimension data(n)
      big=1.0e38
      datamin=big
      datamax=-big
      do i=1,n
         datamin=amin1(datamin,data(i))
         datamax=amax1(datamax,data(i))
      enddo
c     write(6,*) 'datamin=',datamin
c     write(6,*) 'datamax=',datamax
      return
      end
c=======================================================================      
      subroutine dataplot(iwin,x0,y0,w,h,x,y,n,
     $     scxmin,scxmax,ixlogaxis, scymin,scymax,iylogaxis,
     $     isymbol,size,ioutline,ilw,idash,igray,istep)
c=======================================================================
c PURPOSE: TO PLOT DATA
c=======================================================================
c MODIFICATION HISTORY
c 	AUG 26, 1994 ORIGINAL VERSION
c=======================================================================
c     isymbol=0 LINE
c            =1 CIRCLE
c            =2 
      dimension x(n),y(n),gx(2*17777),gy(2*17777)
      dimension gx2(2*17777),gy2(2*17777)
c========= LINE PLOT ===================================================
      if(isymbol.eq.0) then
         call pc_setline(iwin,ilw)
         call pc_setdash(iwin,idash)
	 if(ixlogaxis.eq.0) then
	    do i=1,n
	      if(x(i).gt.scxmax)  then
	        xx=scxmax
	      else if(x(i).lt.scxmin) then
		xx=scxmin
	      else
		xx=x(i)
	      endif
              gx(i)=x0+w*(xx-scxmin)/(scxmax-scxmin)
	    enddo
	 else if(ixlogaxis.eq.1) then
	     scxmin_log=log10(scxmin)
	     scxmax_log=log10(scxmax)
	     do i=1,n
                if(x(i).gt.scxmax)  then
	          xx=scxmax_log
	        else if(x(i).lt.scxmin) then
		  xx=scxmin_log
	        else
	          xx=log10(x(i))
	        endif
                gx(i)=x0+w*(xx-scxmin_log)/(scxmax_log-scxmin_log) 
	     enddo
	 endif
        if(iylogaxis.eq.0) then
            do i=1,n
              if(y(i).gt.scymax)  then
                yy=scymax    
              else if(y(i).lt.scymin) then
                yy=scymin    
              else
                yy=y(i)
              endif  
              gy(i)=y0+h*(yy-scymin)/(scymax-scymin)
            enddo
         else if(iylogaxis.eq.1) then
             scymin_log=log10(scymin)
             scymax_log=log10(scymax)
             do i=1,n
              if(y(i).gt.scymax)  then
                yy=scymax_log    
              else if(y(i).lt.scymin) then
                yy=scymin_log     
              else
                yy=log10(y(i))
              endif  
             gy(i)=y0+h*(yy-scymin_log)/(scymax_log-scymin_log) 
             enddo
         endif
         if ( istep .eq. 0 ) then
	    call pc_plot(iwin,gx,gy,n)
         else
           do i=1,n-1
             gx2(2*i-1)=gx(i)
             gy2(2*i-1)=gy(i)
             gx2(2*i)=gx(i+1)
             gy2(2*i)=gy(i)
           enddo
           gx2(2*n-1)=gx(n)
           gy2(2*n-1)=gy(n)
c 2016/11/17
           gx2(2*n)=gx(n)
           gy2(2*n)=gy(n)
	   call pc_plot(iwin,gx2,gy2,2*n)
         endif
c======== SYMBOL PLOT ==================================================
      else 
         call pc_setgrayshade(iwin,igray)
         do i=1,n 
            if((x(i).ge.scxmin.and.x(i).le.scxmax).and.
     $         (y(i).ge.scymin.and.y(i).le.scymax)) then
            if(ixlogaxis.eq.0) then
               xx=x0+w*(x(i)-scxmin)/(scxmax-scxmin)
            else if(ixlogaxis.eq.1) then 
	       if(x(i).ne.0.) then
                  x_log=log10(x(i))
                  scxmin_log=log10(scxmin)
                  scxmax_log=log10(scxmax)
                  xx=x0+w*(x_log-scxmin_log)/(scxmax_log-scxmin_log)
               endif
            endif 
            if(iylogaxis.eq.0) then
               yy=y0+h*(y(i)-scymin)/(scymax-scymin)
            else if(iylogaxis.eq.1) then 
	       if(y(i).ne.0.) then
                  y_log=log10(y(i))
                  scymin_log=log10(scymin)
                  scymax_log=log10(scymax)
                  yy=y0+h*(y_log-scymin_log)/(scymax_log-scymin_log)
	       endif
            endif 
            if(x(i).ne.0.or.y(i).ne.0.) then
               call pc_symbol(iwin,xx,yy,size,isymbol,ioutline)
            endif
         endif
      enddo  
      endif
      call pc_setgrayshade(iwin,-1)
      return
      end
c=======================================================================
      subroutine gridline(iwin,x0,y0,w,h,scmin,scmax,scint,
     $     w2e,ilogaxis,linewidth,dashtype)
c=======================================================================
c     PURPOSE TO PLOT AXIS
c=======================================================================
c     INPUT ARGUMENS:
c     iwin: OUTPUT WINDOW NUMBER
c     x0     : LOWER LEFT X POSITION
c     y0     : LOWER LEFT Y POSITION
c     w      : AXIS WIDTH
c     h      : AXIS HEIGHT
c     WtoE   : Draw WtoE or StoN
c     scmin  : SCALE MINIMUM
c     scmax  : SCALE MAXIMUM
c     scint  : SCALE INTERVAL
c     w2e   : Draw WtoE or StoN
c     ilogaxis: PLOT 'LOG' or 'LIN' AXIS
c     linewidth: 
c     dashtype:
c=======================================================================
c     MODIFICATION HISTORY
c     AUG 26, 1994 ORIGINAL VERSION
c     AUG 30, 1994 ANOTATION ROUTINE MODIFY
c=======================================================================
      integer w2e,ilogaxis,linewidth,dashtype
      call pc_setline(iwin,linewidth)
      call pc_setdash(iwin,dashtype)
c=======================================================================
c     LINEAR PLOT
c=======================================================================
      if(ilogaxis.eq.0) then
	 l=int(scmin/scint)
	 if(l*scint.gt.scmin) l=l-1
	 m=int(scmax/scint)
	 if(m*scint.le.scmax) m=m+1
	 sc=float(l)*scint
	 eps=0.05*scint
	 do i=l,m
            sc=float(i)*scint
	    if(sc.ge.(scmin-eps).and.sc.le.(scmax+eps)) then 
               if(w2e.eq.1) then
                  x=x0+w
                  y=y0+h*(sc-scmin)/(scmax-scmin)
                  call pc_line(iwin,x0,y,x,y)
               else if(w2e.eq.0) then
                  x=x0+w*(sc-scmin)/(scmax-scmin)
                  y=y0+h
                  call pc_line(iwin,x,y0,x,y)
	       endif
	    endif
	 enddo
c=======================================================================
c     LOG PLOT
c=======================================================================
      else if(ilogaxis.eq.1) then
         i1=int(log10(scmin))
         i2=int(log10(scmax))+1
         if(log10(scmin).lt.0.) i1=i1-1
         if(log10(scmax).lt.0.) i2=i2-1
         scmin_log=log10(scmin)
         scmax_log=log10(scmax)
         do i=i1,i2
            do j=1,9
               sc=j*10.**float(i)
               sc_log=log10(sc)
               if(sc.ge.scmin.and.sc.le.scmax) then
                  if(w2e.eq.1) then
                     x=x0+w
                     y=y0+h*(sc_log-scmin_log)/(scmax_log-scmin_log)
                     call pc_line(iwin,x0,y,x,y)
                  else if(w2e.eq.0) then
                     x=x0+w*(sc_log-scmin_log)/(scmax_log-scmin_log)
                     y=y0+h
                     call pc_line(iwin,x,y0,x,y)
	          endif
               endif
            enddo
         enddo
      endif
      call pc_setdash(iwin,1)
      return
      end
c=======================================================================
      subroutine meanscale(isctype,dtmin,dtmax,ilog,nintmax,
     $                     scmin,scmax,scint,nint)
c=======================================================================
cPURPOSE: ʿΧκ
c=======================================================================
c INPUT ARGUMENTS:
c     isctype: scaletype
c              0: NORMAL SCALE
c 	       1: MAP SCALE
c     dtmin:   ǡκǾ
c     dtmax:   ǡκ
c     ilog:    LOGSCALE
c           =1 LOG
c           =0 LINEAR
c     nintmax: ֳֿκ
c=======================================================================
c OUTPUT ARGUMENUS:
c     scmin:   κǾ
c     scmax:   κ
c     scint:   δֳ
c     nint:    ºݤδֳֿ
c=======================================================================
c  MODIFICATION HISTORY
c     AUG 26, 1994 ORIGINAL VERSION
c     AUG 29, 1994 MAKE MAP SCALE TYPE 
c=======================================================================
      real isc(11),dtmin,dtmax,scmin,scmax,scint
      integer scnormal(8),scmap(10)
      integer nintmax,nint
      data scnormal / 1,2,5,10,20,25,50,100 /
      data scmap / 1,2,5,10,20,50,15,30,45,60/
      
      if(isctype.eq.0) then
	nisc=8
	do i=1,nisc
		isc(i)=scnormal(i)
	enddo
      else if(isctype.eq.1) then
        nisc=10
        do i=1,nisc
                isc(i)=scmap(i)
        enddo
      endif

      tmpdtmin=dtmin
      tmpdtmax=dtmax
      if(ilog.eq.1) then
         dtmin=log10(dtmin)
         dtmax=log10(dtmax)
      endif
      droot=10.
      dif=dtmax-dtmin
      if(dif.lt.1.) then
	 nten=int(log10(1./dif))+1
	 nten=-nten
      else
         nten=int(log10(dif))-1
      endif
      dnice=droot**nten
      is=1
      if(isctype.eq.1.and.dif.ge.35.) then
	is=7
	dnice=1.0
      endif
      do i=is,nisc
         dnice2=isc(i)*dnice
         h=int(dtmax/dnice2)
         if(h*dnice2.lt.dtmax) h=h+1
         l=int(dtmin/dnice2)
         if(l*dnice2.gt.dtmin) l=l-1
         n=h-l
         if(n.le.nintmax) then
            dnicenum=dnice2
            goto 999
         endif
      enddo
 999  scmin=dnicenum*l
      scmax=dnicenum*h
      scint=dnicenum
      if(ilog.eq.1) then
         scmin=10.**scmin
         scmax=10.**scmax
      endif
      nint=h-l+1
      dtmin=tmpdtmin
      dtmax=tmpdtmax
      return
      end
c=======================================================================
      subroutine axis(iwin,x0,y0,w,h,WSENwsen,scmin,scmax,scint,
     $     ilogaxis,iaxispen,itickpen,tick,f1,o1,f2,label,nlength)
c=======================================================================
c     PURPOSE TO PLOT AXIS
c=======================================================================
c     INPUT ARGUMENS:
c     iwin: OUTPUT WINDOW NUMBER
c     x0     : LOWER LEFT X POSITION
c     y0     : LOWER LEFT Y POSITION
c     w      : AXIS WIDTH
c     h      : AXIS HEIGHT
c     WSENwsen   : AXIS TYPE 'W','S','E','N','w','s','e','n'
c     scmin  : SCALE MINIMUM
c     scmax  : SCALE MAXIMUM
c     scint  : SCALE INTERVAL
c     ilogaxis: PLOT 'LOG' or 'LIN' AXIS
c     iaxispen: AXIS LINE WIDTH
c     itickpen: TICK LINE WIDTH
c     tick   : TICK LENGTH, DEFAULT OUTER TICK
c     f1     : ANOTATION FONT SIZE
c     o1     : OFFSET OF ANOTATION FROM AXIS
c     f2     : LABEL FONT SIZE
c     label  : TITLE OF LABEL
c     nlength: CHARACTER LENGTH OF label
c=======================================================================
c     MODIFICATION HISTORY
c     AUG 26, 1994 ORIGINAL VERSION
c     AUG 30, 1994 ANOTATION ROUTINE MODIFY
c=======================================================================
      character WSENwsen*1,text*50,label*50,fmt*20
c=====SAVE SACLE PARAMETER ============================================
      tmpscmin=scmin
      tmpscmax=scmax
      tmpscint=scint
c=======================================================================
cc      ox=3.5*f1+o1
cc      oy=2.0*f1+o1
      ox=2.5*f1+o1
      oy=2.0*f1+o1
      call pc_setline(iwin,iaxispen)
      if(WSENwsen.eq.'W') then
	 call pc_line(iwin,x0,y0,x0,y0+h)
         call pc_text(iwin,x0-ox,y0+h/2.,f2,label,90.,nlength,2)
      else if(WSENwsen.eq.'w') then
         call pc_line(iwin,x0,y0,x0,y0+h)
      else if(WSENwsen.eq.'E') then
         call pc_line(iwin,x0+w,y0,x0+w,y0+h)
         call pc_text(iwin,x0+w+ox,y0+h/2.,f2,label,90.,nlength,8)
      else if(WSENwsen.eq.'e') then
         call pc_line(iwin,x0+w,y0,x0+w,y0+h)
      else if(WSENwsen.eq.'S') then
         call pc_line(iwin,x0,y0,x0+w,y0)
	 call pc_text(iwin,x0+w/2.,y0-oy,f2,label,0.,nlength,8)
      else if(WSENwsen.eq.'s') then
         call pc_line(iwin,x0,y0,x0+w,y0)
      else if(WSENwsen.eq.'N') then
         call pc_line(iwin,x0,y0+h,x0+w,y0+h)
         call pc_text(iwin,x0+w/2.,y0+h+oy,f2,label,0.,nlength,2)
      else if(WSENwsen.eq.'n') then
         call pc_line(iwin,x0,y0+h,x0+w,y0+h)
      endif
      
      call pc_setline(iwin,itickpen)
c=======================================================================
c     LINEAR PLOT
c=======================================================================
      if(ilogaxis.eq.0) then
	 l=int(scmin/scint)
	 if(l*scint.gt.scmin) l=l-1
	 m=int(scmax/scint)
	 if(m*scint.le.scmax) m=m+1
	 sc=float(l)*scint
c     write(6,*) '(l,m)',l,m,l*scint,m*scint
c     write(6,*) 'sc (min,max)',scmin,scmax
c     sc=scmin
         scmod=1.
	 ilog=int(log10(scint))
	 if(scint.lt.1.) ilog=ilog-1
c     ================ SCALE MODIFICATION ================================== 
	 if(ilog.ge.3.or.ilog.le.-3) then  
c     ilog=ilog+1
	    scmod=10.**float(ilog)
	    sc=sc/scmod
	    scmin=scmin/scmod
	    scmax=scmax/scmod
	    scint=scint/scmod
	    ox=2.5*f1+o1
	    oy=1.5*f1+o1
            if(WSENwsen.eq.'W') then
               if(iwin.eq.10) then
                  write(text,'(a2,4h10@+,i3,2h@+)') 
     $                 'X ',ilog
                  call pc_text(iwin,x0-ox,y0+h,f1,text,90.,11,6)
               else
                  write(text,'(5hX 10^,i3)') ilog
                  call pc_text(iwin,x0-ox,y0+h,f1,text,90.,8,6)
               endif
            else if(WSENwsen.eq.'E') then
               if(iwin.eq.10) then
                  write(text,'(a2,4h10@+,i3,2h@+)') 
     $                 'X ',ilog
                  call pc_text(iwin,x0+w+ox,y0+h,f1,text,90.,11,6)
               else
                  write(text,'(5hX 10^,i3)') ilog
                  call pc_text(iwin,x0+w+ox,y0+h,f1,text,90.,8,6)
               endif
            else if(WSENwsen.eq.'S') then
               if(iwin.eq.10) then
                  write(text,'(a2,4h10@+,i3,2h@+)') 
     $                 'X ',ilog
                  call pc_text(iwin,x0+w,y0-oy,f1,text,0.,11,6)
               else
                  write(text,'(5hX 10^,i3)') ilog
                  call pc_text(iwin,x0+w,y0-oy,f1,text,0.,8,6)
               endif
            else if(WSENwsen.eq.'N') then
               if(iwin.eq.10) then
                  write(text,'(a2,4h10@+,i3,2h@+)') 
     $                 'X ',ilog
                  call pc_text(iwin,x0+w,y0+h+oy,f1,text,0.,11,6)
               else
                  write(text,'(5hX 10^,i3)') ilog
                  call pc_text(iwin,x0+w,y0+h+oy,f1,text,0.,8,6)
               endif
	    endif
         endif
c==============ANOTATION ==============================================
	 xc=log10(abs(scint))
	 ixc=int(xc)
	 decimal=xc-ixc
	 factor=10.**(decimal)
c     write(6,*) '(factor,decimal)',factor,decimal
	 if(factor.lt.1.) factor=10.*factor
	 if(factor.ge.2.45.and.factor.le.2.55) then
            i25=1
	 else
            i25=0
	 endif
	 if(i25.eq.1) then
            nfig=1
	 else
            nfig=0
	 endif
         if(scint.lt.1..and.decimal.ne.0.) ixc=ixc-1
	 if(ixc.lt.0) then
            ndfig=abs(ixc)+nfig
	 else
            ndfig=0
	 endif
c     write(6,*) '(nfig,ndfig)=',nfig,ndfig
	 do i=l,m
            sc=float(i)*scint
c     write(6,*) i,sc
	    eps=0.001*scint
            if (sc.ge.scmin-eps.and.sc.le.scmax+eps) then
c================CHECK SIGN OF SC =====================================
               if(sc.lt.0.) then
                  minus=1
               else
                  minus=0
               endif
               if(sc.ne.0.) then
                  sc10=log10(abs(sc))
	          isc=nint(sc10)
               else
                  isc=0
               endif
               if(isc.lt.0) then
                  nifig=1
               else if(isc.eq.0) then
                  nifig=1
               else if(isc.gt.0) then
                  nifig=isc+1
               endif
c     write(6,*) '(nifig,ndfig)',nifig,ndfig
               if(ndfig.eq.0) then
		  write(fmt,'(a2,i1,a1)') '(i',nifig+minus,')'
		  ntext=nifig+minus
               else 
c=================+1 for '.' ==========================================
		  write(fmt,'(a2,i1,a1,i1,a1)') 
     $                 '(f',nifig+ndfig+minus+1,'.',ndfig,')'
		  ntext=nifig+ndfig+minus+1
               endif
c===============FOR DEBUG =============================================
c     write(6,*) fmt,ntext
c=======================================================================
               if(WSENwsen.eq.'W') then
                  x=x0
                  y=y0+h*(sc-scmin)/(scmax-scmin)
                  call pc_line(iwin,x,y,x-tick,y)
                  if(ndfig.eq.0) then
                     write(text,fmt) nint(sc)
                  else
                     write(text,fmt) sc
                  endif
                  call pc_text(iwin,x-o1,y,f1,text,0.,ntext,6)
               else if(WSENwsen.eq.'w') then
                  x=x0
                  y=y0+h*(sc-scmin)/(scmax-scmin)
                  call pc_line(iwin,x,y,x-tick,y)
               else if(WSENwsen.eq.'E') then
                  x=x0+w
                  y=y0+h*(sc-scmin)/(scmax-scmin)
                  call pc_line(iwin,x,y,x+tick,y)
                  if(ndfig.eq.0) then
                     write(text,fmt) nint(sc)
                  else
                     write(text,fmt) sc
                  endif
                  call pc_text(iwin,x+o1,y,f1,text,0.,ntext,4)
               else if(WSENwsen.eq.'e') then
                  x=x0+w
                  y=y0+h*(sc-scmin)/(scmax-scmin)
                  call pc_line(iwin,x,y,x+tick,y)
               else if(WSENwsen.eq.'S') then
                  x=x0+w*(sc-scmin)/(scmax-scmin)
                  y=y0
                  call pc_line(iwin,x,y,x,y-tick)
                  if(ndfig.eq.0) then
                     write(text,fmt) nint(sc)
                  else
                     write(text,fmt) sc
                  endif
                  call pc_text(iwin,x,y-o1,f1,text,0.,ntext,8)
               else if(WSENwsen.eq.'s') then
                  x=x0+w*(sc-scmin)/(scmax-scmin)
                  y=y0
                  call pc_line(iwin,x,y,x,y-tick)
               else if(WSENwsen.eq.'N') then
                  x=x0+w*(sc-scmin)/(scmax-scmin)
                  y=y0+h
                  call pc_line(iwin,x,y,x,y+tick)
                  if(ndfig.eq.0) then
                     write(text,fmt) nint(sc)
                  else
                     write(text,fmt) sc
                  endif
                  call pc_text(iwin,x,y+o1,f1,text,0.,ntext,2)
               else if(WSENwsen.eq.'n') then
                  x=x0+w*(sc-scmin)/(scmax-scmin)
                  y=y0+h
                  call pc_line(iwin,x,y,x,y+tick)
               endif
            endif
	 enddo
c=======================================================================
c     LOG PLOT
c=======================================================================
      else if(ilogaxis.eq.1) then
         i1=int(log10(scmin))
         i2=int(log10(scmax))+1
         if(log10(scmin).lt.0.) i1=i1-1
         if(log10(scmax).lt.0.) i2=i2-1
c     write(6,*) 'i1,i2=',i1,i2
         scmin_log=log10(scmin)
         scmax_log=log10(scmax)
         do i=i1,i2
            do j=1,9
               sc=j*10.**i
               sc_log=log10(sc)
               if(sc.ge.scmin.and.sc.le.scmax) then
                  if(WSENwsen.eq.'W') then
                     x=x0
                     y=y0+h*(sc_log-scmin_log)/(scmax_log-scmin_log)
                     call pc_line(iwin,x,y,x-tick/2.,y)
                     if(j.eq.1) then
                        call pc_line(iwin,x,y,x-tick,y)
                        if(iwin.eq.10) then
                           write(text,'(4h10@+,i3,2h@+)') i
                           call pc_text(iwin,x-o1,y,f1,text,0.,9,6)
                        else
                           call pc_text(iwin,x-o1-f1,y,
     $                          f1,'10',0.,2,6)
                           write(text,'(i3)') i
                           call pc_text(iwin,x-o1,y+0.5*f1,
     $                          0.7*f1,text,0.,3,6)
                        endif
                     endif
                  else if(WSENwsen.eq.'w') then
                     x=x0
                     y=y0+h*(sc_log-scmin_log)/(scmax_log-scmin_log)
                     if(j.eq.1) then
                        tic=tick
                     else
                        tic=tick/2.
                     endif
                     call pc_line(iwin,x,y,x-tic,y)
                  else if(WSENwsen.eq.'E') then
                     x=x0+w
                     y=y0+h*(sc_log-scmin_log)/(scmax_log-scmin_log)
                     call pc_line(iwin,x,y,x+tick/2.,y)
                     if(j.eq.1) then
                        call pc_line(iwin,x,y,x+tick,y)
                        if(iwin.eq.10) then
                           write(text,'(4h10@+,i3,2h@+)') i
                           call pc_text(iwin,x+o1,y,f1,text,0.,9,4)
                        else
                           call pc_text(iwin,x+o1,y,f1,'10',0.,2,4)
                           write(text,'(i3)') i
                           call pc_text(iwin,x+o1+f1,
     $                          y+0.5*f1,0.7*f1,text,0.,3,4)
                        endif
                     endif
                  else if(WSENwsen.eq.'e') then
                     x=x0+w
                     y=y0+h*(sc_log-scmin_log)/(scmax_log-scmin_log)
                     if(j.eq.1) then
                        tic=tick
                     else  
                        tic=tick/2.
                     endif
                     call pc_line(iwin,x,y,x+tic,y)
                  else if(WSENwsen.eq.'S') then
                     x=x0+w*(sc_log-scmin_log)/(scmax_log-scmin_log)
                     y=y0
                     call pc_line(iwin,x,y,x,y-tick/2.)
                     if(j.eq.1) then
                        call pc_line(iwin,x,y,x,y-tick)
                        if(iwin.eq.10) then
                           write(text,'(4h10@+,i3,2h@+)') i
                           call pc_text(iwin,x,y-o1,f1,text,0.,9,8)
                        else
                           call pc_text(iwin,x,y-o1,f1,'10',0.,2,9)
                           write(text,'(i3)') i
                           call pc_text(iwin,x,y-o1+0.5*f1,
     $                          0.7*f1,text,0.,3,7)
                        endif
                     endif
                  else if(WSENwsen.eq.'s') then
                     x=x0+w*(sc_log-scmin_log)/(scmax_log-scmin_log)
                     y=y0
                     if(j.eq.1) then
                        tic=tick
                     else  
                        tic=tick/2.
                     endif
                     call pc_line(iwin,x,y,x,y-tic)
                  else if(WSENwsen.eq.'N') then
                     x=x0+w*(sc_log-scmin_log)/(scmax_log-scmin_log)
                     y=y0+h
                     call pc_line(iwin,x,y,x,y+tick/2.)
                     if(j.eq.1) then
                        call pc_line(iwin,x,y,x,y+tick)
                        if(iwin.eq.10) then
                           write(text,'(4h10@+,i3,2h@+)') i
                           call pc_text(iwin,x,y+o1,f1,text,0.,9,2)
                        else
                           jj=3
                           call pc_text(iwin,x,y+o1,f1,
     $                          '10',0.,2,jj)
                           write(text,'(i3)') i
                           call pc_text(iwin,x,y+o1+0.5*f1,
     $                          0.7*f1,text,0.,3,1)
                        endif
                     endif
                  else if(WSENwsen.eq.'n') then
                     x=x0+w*(sc_log-scmin_log)/(scmax_log-scmin_log)
                     y=y0+h
                     if(j.eq.1) then
                        tic=tick
                     else  
                        tic=tick/2.
                     endif
                     call pc_line(iwin,x,y,x,y+tic)
                  endif
               endif
            enddo
         enddo
      endif
c=======================================================================
      scmin=tmpscmin    
      scmax=tmpscmax
      scint=tmpscint
c=======================================================================
      return
      end

      subroutine tmaxis(iwin,x0,y0,w,h,WSENwsen,
     $     iyr1,imo1,idy1,ihr1,imi1,
     $     iyr2,imo2,idy2,ihr2,imi2,
     $     tick,f1,o1,f2,label,nlength)
c=======================================================================
c PURPOSE: PLOT TIME AXIS
c=======================================================================
c INPUT ARGUMENTS:
c	iwin:
c	(x0,y0): LOWER LEFT CORNER
c	(w,h): WIDTH,HEIGHT
c	WSENwsen: AXIS 'W",'E','S','N'
c	ijul1: julday(m,d,y)-julday(12,31,1899) START TIME
c       hms1: (60*hour+min+sec/60.)/1440.
c       ijul2: julday(m,d,y)-julday(12,31,1899) END TIME
c       hms2: (60*hour+min+sec/60.)/1440.
c	tick: tick length
c	f1,f2: fontsize anotation,label
c	o1: offset anotation from axis
c	label: label
c       nlength: strlen(label)
c=======================================================================
c OUTPUT ARGUMENTS:
c=======================================================================
c SUBROUTINE CALL: anot, caldat, xgtool
c=======================================================================
c FUNCTION CALL: julday
c=======================================================================
c MODIFICATION HISTORY
c       AUG 26, 1994 ORIGINAL VERSION
c=======================================================================
      character WSENwsen*1,text*50,label*50
      real*8 tm,tm1,tm2,dtm
      real*8 time,timemin,timemax
      character cmon(12)*3
      data cmon/ 'JAN','FEB','MAR','APR','MAY','JUN',
     $     'JUL','AUG','SEP','OCT','NOV','DEC'/
      ox=3.5*f1+o1
      oy=2.0*f1+o1
      call pc_setline(iwin,4)
      if(WSENwsen.eq.'W') then
         call pc_line(iwin,x0,y0,x0,y0+h)
         call pc_text(iwin,x0-ox,y0+h/2.,f2,label,90.,nlength,2)
      else if(WSENwsen.eq.'w') then
         call pc_line(iwin,x0,y0,x0,y0+h)
      else if(WSENwsen.eq.'E') then
         call pc_line(iwin,x0+w,y0,x0+w,y0+h)
         call pc_text(iwin,x0+w+ox,y0+h/2.,f2,label,90.,nlength,8)
      else if(WSENwsen.eq.'e') then
         call pc_line(iwin,x0+w,y0,x0+w,y0+h)
      else if(WSENwsen.eq.'S') then
         call pc_line(iwin,x0,y0,x0+w,y0)
         call pc_text(iwin,x0+w/2.,y0-oy,f2,label,0.,nlength,8)
      else if(WSENwsen.eq.'s') then
         call pc_line(iwin,x0,y0,x0+w,y0)
      else if(WSENwsen.eq.'N') then
         call pc_line(iwin,x0,y0+h,x0+w,y0+h)
         call pc_text(iwin,x0+w/2.,y0+h+oy,f2,label,0.,nlength,2)
      else if(WSENwsen.eq.'n') then
         call pc_line(iwin,x0,y0+h,x0+w,y0+h)
      endif
      call pc_setline(iwin,1)

      call calmin(tm1,iyr1,imo1,idy1,ihr1,imi1,0.0)
      call calmin(tm2,iyr2,imo2,idy2,ihr2,imi2,0.0)
      dtm=tm2-tm1
      itm=int(dtm)
c     jtime=0
      juldt=dtm/1440.0
      timemin=tm1
      timemax=tm2
      jtime=0
      if(itm .gt. 180) jtime=0
      if(juldt.gt.1) jtime=1       !DAY
      if(juldt.gt.100) jtime=2     !MON
      if(juldt.gt.1000) jtime=3    !YEAR
      if(juldt.gt.10000) jtime=4   !10YEAR
c============ ANOT HOUR =================================================
      if(jtime.eq.0) then
         call calmin(tm,iyr1,imo1,idy1,0,0,0.0)
         dtime=30.0
         do while(tm.le.tm2)
            call invcalmin(tm,iyr,imo,idy,ihr,imi,sc)
            write(text,'(i2.2)') ihr
c            write(6,*) iyr,imo,idy,ihr,imi,sc
            call tmanot(iwin,x0,y0,w,h,WSENwsen,tm,dtime,
     $           timemin,timemax,tick,text,2,f1,o1)
            ihr=ihr+1
            call calmin(tm,iyr,imo,idy,ihr,imi,sc)
         enddo
c============ ANOT DAY =================================================
      else if(jtime.eq.1) then
         ijul1 = julday(imo1,idy1-1,iyr1)
         ijul2 = julday(imo2,idy2+1,iyr2)
         iday=ijul1
         nd=1
         if(juldt.gt.28) nd=2 
         dtime=0.5*1440.0
         do while(iday.le.ijul2)
            call caldat(iday,im,id,iy)
            call calmin(time,iy,im,id,0,0,0.0)
            write(text,'(i2.2)') id
            call tmanot(iwin,x0,y0,w,h,WSENwsen,time,dtime,
     $           timemin,timemax,tick,text,2,f1,o1)
            iday=iday+nd
         enddo
c============ ANOT MONTH ===============================================
      else if(jtime.eq.2) then
         ijul1 = julday(imo1-1,1,iyr1)
         ijul2 = julday(imo2+1,1,iyr2)
         iday=ijul1
         nm=1
	 ntext=3
         if(juldt.gt.730) then 
		nm=1
		ntext=1
	 endif
         dtime=15.*1440.0
         do while(iday.lt.ijul2)
            call caldat(iday,im,id,iy)
            call calmin(time,iy,im,id,0,0,0.0)
            write(text,'(a3)') cmon(im)
            call tmanot(iwin,x0,y0,w,h,WSENwsen,time,dtime,
     $                timemin,timemax,tick,text,ntext,f1,o1)
            im=im+nm
            if ( im.gt.12) then
               im=im-12
               iy=iy+1
            endif
            iday=julday(im,1,iy)
         enddo
c============ ANOT YEAR =================================================
      else if(jtime.eq.3) then
         ijul1 = julday(imo1,idy1,iyr1-1)
         ijul2 = julday(imo2,idy2,iyr2+1)
         iday=ijul1
         ny=1
	 dtime=365./2.*1440.0
         do while(iday.lt.ijul2)
            call caldat(iday,im,id,iy)
            call calmin(time,iy,im,id,0,0,0.0)
            iminus=int(iy/100)*100
            write(text,'(i2.2)') iy-iminus
            call tmanot(iwin,x0,y0,w,h,WSENwsen,time,dtime,
     $                timemin,timemax,tick,text,2,f1,o1)
            iy=iy+ny
            iday=julday(1,1,iy)
         enddo
c============ ANOT 10 YEAR  ============================================
      else if(jtime.eq.4) then
         iyr1=10*int(iyr1/10)
         iyr2=10*int(iyr2/10)
         ijul1 = julday(1,1,iyr1-10)
         ijul2 = julday(1,1,iyr2+10)
         iday=ijul1
         ny=10
	 dtime=365./2.*1440.0
         do while(iday.lt.ijul2)
            call caldat(iday,im,id,iy)
            call calmin(time,iy,im,id,0,0,0.0)
            iminus=int(iy/100)*100
            write(text,'(i2.2)') iy-iminus
            call tmanot(iwin,x0,y0,w,h,WSENwsen,time,dtime,
     $                timemin,timemax,tick,text,2,f1,o1)
            iy=iy+ny
            iday=julday(1,1,iy)
         enddo
      endif
      return
      end
      
      subroutine tmanot(iwin,x0,y0,w,h,WSENwsen,time,dtime,
     $                timemin,timemax,tick,text,nanot,f1,o1)
c=======================================================================
c PURPOSE:
c=======================================================================
c INPUT ARGUMENTS:
c=======================================================================
c OUTPUT ARGUMENTS:
c=======================================================================
c SUBROUTINE CALL: xgtool
c=======================================================================
c FUNCTION CALL:
c=======================================================================
c MODIFICATION HISTORY
c       AUG 26, 1994 ORIGINAL VERSION
c=======================================================================
      character WSENwsen*1,text*50
      real*8 time,timemin,timemax,tm,tm1
      tm = time
      tm1 = time+dtime
      if ( (tm .ge. timemin) .and. (tm .le. timemax) ) then
         itick=1
      else
         itick=0
      endif
      if ( (tm1 .ge. timemin) .and. (tm1 .le. timemax) ) then
         itext=1
      else
         itext=0
      endif
      if(WSENwsen.eq.'W') then
         x=x0
         y=y0+h*(time-timemin)/(timemax-timemin)
         ytxt=y0+h*(time+dtime-timemin)/(timemax-timemin)
         if (itick.eq.1) call pc_line(iwin,x,y,x-tick,y)
         if (itext.eq.1) call pc_text(iwin,x-o1,ytxt,f1,text,0.,nanot,6)
      else if(WSENwsen.eq.'w') then
         x=x0
         y=y0+h*(time-timemin)/(timemax-timemin)
         if (itick.eq.1) call pc_line(iwin,x,y,x-tick,y)
      else if(WSENwsen.eq.'E') then
         x=x0+w
         y=y0+h*(time-timemin)/(timemax-timemin)
         ytxt=y0+h*(time+dtime-timemin)/(timemax-timemin)
         if (itick.eq.1) call pc_line(iwin,x,y,x+tick,y)
         if (itext.eq.1) call pc_text(iwin,x+o1,ytxt,f1,text,0.,nanot,4)
      else if(WSENwsen.eq.'e') then
         x=x0+w
         y=y0+h*(time-timemin)/(timemax-timemin)
         if (itick.eq.1) call pc_line(iwin,x,y,x+tick,y)
      else if(WSENwsen.eq.'S') then
         x=x0+w*(time-timemin)/(timemax-timemin)
         xtxt=x0+w*(time+dtime-timemin)/(timemax-timemin)
         y=y0
         if (itick.eq.1) call pc_line(iwin,x,y,x,y-tick)
         if (itext.eq.1) call pc_text(iwin,xtxt,y-o1,f1,text,0.,nanot,8)
      else if(WSENwsen.eq.'s') then
         x=x0+w*(time-timemin)/(timemax-timemin)
         y=y0
         if (itick.eq.1) call pc_line(iwin,x,y,x,y-tick)
      else if(WSENwsen.eq.'N') then
         x=x0+w*(time-timemin)/(timemax-timemin)
         xtxt=x0+w*(time+dtime-timemin)/(timemax-timemin)
         y=y0+h
         if (itick.eq.1) call pc_line(iwin,x,y,x,y+tick)
         if (itext.eq.1) call pc_text(iwin,xtxt,y+o1,f1,text,0.,nanot,2)
      else if(WSENwsen.eq.'n') then
         x=x0+w*(time-timemin)/(timemax-timemin)
         y=y0+h
         if (itick.eq.1) call pc_line(iwin,x,y,x,y+tick)
      endif
      return
      end

      subroutine tmtick(iwin,x0,y0,w,h,WSENwsen,time,dtime,
     $                timemin,timemax,tick,text,nanot,f1,o1)
c=======================================================================
c PURPOSE:
c=======================================================================
c INPUT ARGUMENTS:
c=======================================================================
c OUTPUT ARGUMENTS:
c=======================================================================
c SUBROUTINE CALL: xgtool
c=======================================================================
c FUNCTION CALL:
c=======================================================================
c MODIFICATION HISTORY
c       AUG 26, 1994 ORIGINAL VERSION
c=======================================================================
      character WSENwsen*1,text*50
      real*8 time,timemin,timemax,tm,tm1
      tm = time
      if ( (tm .ge. timemin) .and. (tm .le. timemax) ) then
         itick=1
      else
         itick=0
      endif
      if(WSENwsen.eq.'W') then
         x=x0
         y=y0+h*(time-timemin)/(timemax-timemin)
         ytxt=y0+h*(time+dtime-timemin)/(timemax-timemin)
         if (itick.eq.1) call pc_line(iwin,x,y,x-tick,y)
      else if(WSENwsen.eq.'w') then
         x=x0
         y=y0+h*(time-timemin)/(timemax-timemin)
         if (itick.eq.1) call pc_line(iwin,x,y,x-tick,y)
      else if(WSENwsen.eq.'E') then
         x=x0+w
         y=y0+h*(time-timemin)/(timemax-timemin)
         ytxt=y0+h*(time+dtime-timemin)/(timemax-timemin)
         if (itick.eq.1) call pc_line(iwin,x,y,x+tick,y)
      else if(WSENwsen.eq.'e') then
         x=x0+w
         y=y0+h*(time-timemin)/(timemax-timemin)
         if (itick.eq.1) call pc_line(iwin,x,y,x+tick,y)
      else if(WSENwsen.eq.'S') then
         x=x0+w*(time-timemin)/(timemax-timemin)
         xtxt=x0+w*(time+dtime-timemin)/(timemax-timemin)
         y=y0
         if (itick.eq.1) call pc_line(iwin,x,y,x,y-tick)
      else if(WSENwsen.eq.'s') then
         x=x0+w*(time-timemin)/(timemax-timemin)
         y=y0
         if (itick.eq.1) call pc_line(iwin,x,y,x,y-tick)
      else if(WSENwsen.eq.'N') then
         x=x0+w*(time-timemin)/(timemax-timemin)
         xtxt=x0+w*(time+dtime-timemin)/(timemax-timemin)
         y=y0+h
         if (itick.eq.1) call pc_line(iwin,x,y,x,y+tick)
      else if(WSENwsen.eq.'n') then
         x=x0+w*(time-timemin)/(timemax-timemin)
         y=y0+h
         if (itick.eq.1) call pc_line(iwin,x,y,x,y+tick)
      endif
      return
      end
