c-----------------------------------------------------------------------
      program main
      implicit real*8(a-h,o-z)
      character line*128

      xjul=-1.0
      xmag0=-99.9
 100  format(i4,i2,i2,i2,i2,i2)
      narg=iargc()
c      write(0,*) 'nargc=',narg
      do i=1,narg
         call getarg(i,line)
         if( line(1:2) .eq. '-m' ) then
           read(line(3:128),*) xmag0
         else if( line(1:2) .eq. '-r' ) then
           read(line(3:128),100) iyr0,imo0,idy0,ihr0,imi0,isc0
           sc0=dble(isc0)
           jul0 = julday(imo0,idy0,iyr0)
           xjul = jul0 + 
     $       dble(ihr0)/24.0d0 + dble(imi0)/1440.0d0 + sc0/86400.0d0
         endif
      enddo
 
      write(6,'(a,a)') '   ',
     $     'no.  longitude    latitude         mag     days     depth'
 
      n=0
 10   read(5,*,end=999) iyr,imo,idy,ihr,imi,sc,xlon,xlat,xdep,xmag
      n=n+1
      if ( n .eq. 1 .and. xjul .le. 0.0 ) then
        jul0 = julday(imo,idy,iyr)
        xjul = jul0 + 
     $       dble(ihr)/24.0d0 + dble(imi)/1440.0d0 + sc/86400.0d0
      endif
      ijul=julday(imo,idy,iyr)
      x = ijul + 
     $    dble(ihr)/24.0d0 + dble(imi)/1440.0d0 + sc/86400.0d0 -xjul
      if ( xmag .ge. xmag0) then
        write(6,7621) n,xlon,xlat, xmag,x,xdep,iyr,imo,idy
      endif
 7621 format(i7,2f12.5,f12.1,f12.5,f7.1,3x,8x,i5,2i3)
      go to 10
 999  stop
      end

c     // JULDAY
      FUNCTION JULDAY(MM,ID,IYYY)
c=======================================================================
c     THIS ROUTINE FROM NUMERICAL RECIPES
c=======================================================================
      PARAMETER (IGREG=15+31*(10+12*1582))
      IF (IYYY.EQ.0) PAUSE 'There is no Year Zero.'
      IF (IYYY.LT.0) IYYY=IYYY+1
      IF (MM.GT.2) THEN
         JY=IYYY
         JM=MM+1
      ELSE
         JY=IYYY-1
         JM=MM+13
      ENDIF
      JULDAY=INT(365.25*JY)+INT(30.6001*JM)+ID+1720995
      IF (ID+31*(MM+12*IYYY).GE.IGREG) THEN
         JA=INT(0.01*JY)
         JULDAY=JULDAY+2-JA+INT(0.25*JA)
      ENDIF
      RETURN
      END
c     // CALDAT
      SUBROUTINE CALDAT(JULIAN,MM,ID,IYYY)
c=======================================================================
c     THIS ROUTINE FROM NUMERICAL RECIPES
c=======================================================================
      PARAMETER (IGREG=2299161)
      IF(JULIAN.GE.IGREG)THEN
         JALPHA=INT(((JULIAN-1867216)-0.25)/36524.25)
         JA=JULIAN+1+JALPHA-INT(0.25*JALPHA)
      ELSE
         JA=JULIAN
      ENDIF
      JB=JA+1524
      JC=INT(6680.+((JB-2439870)-122.1)/365.25)
      JD=365*JC+INT(0.25*JC)
      JE=INT((JB-JD)/30.6001)
      ID=JB-JD-INT(30.6001*JE)
      MM=JE-1
      IF(MM.GT.12)MM=MM-12
      IYYY=JC-4715
      IF(MM.GT.2)IYYY=IYYY-1
      IF(IYYY.LE.0)IYYY=IYYY-1
      RETURN
      END

