#!/usr/bin/wish

#set hypo hypo.dat
#set hypo xlist.dat
set hypo $env(ETAS_CATALOG)
set winscale 0.8
set h 8
set h1 2
set h2 7
set amax0 4.5
set amaxx0 3.0
set optPLTmax 0
set optNTM 0
set optLOG 0

# plot config
set ps_mf 0
set ps_np 1
set ps_xy_n0 1
set ps_z_n0 1
set ps_xy_n1 0
set ps_z_n1 0
set ps_hypo 0
set ps_mon 0
set ps_monx 0
set ps_label ""
set ps_pdf 0

for { set j 0 } { $j < $argc } { incr j } {
    set tmpargv [lindex $argv $j]
    set optflag [string range $tmpargv 0 1]
    if { $optflag == "-s" } {
        set winscale [string range $tmpargv 2 [string length $tmpargv]]
    } elseif { $optflag == "-b" } {
        set h [string range $tmpargv 2 [string length $tmpargv]]
    } elseif { $optflag == "-t" } {
        set optPLTmax [string range $tmpargv 2 [string length $tmpargv]]
    } 
}

set fp [open $env(ETAS_CATALOG) r]
gets $fp line
scan $line "%d %d %d %d %d %f" yr0 mo0 dy0 hr0 mi0 sc0
close $fp
set t0 [format "%d %d %d %d %d %f" $yr0 $mo0 $dy0 $hr0 $mi0 $sc0]

#set Mc 3.0
#set Mz 4.0
#set tstart 0.1
#set tend 10.0
#set Zts 0.0
#set Zte 10.0

#set mu 0.0
#set K 10.0
#set c 0.03
#set alpha 0.5
#set p 0.9

set aic2 0
set aic2_1 0
set aic2_2 0
set aic2_12 0
set aic2_diff 0
set aic2_3 0
set setting 0
set gradient 99999
set fix "00000"
set suffix ""

set file etas.out
set fp [open $file r]
gets $fp line
gets $fp line
scan $line "%f %f %f" Zts tend tstart
gets $fp line
scan $line "%f %f" Mc Mz
gets $fp line
scan $line "%f %f %f %f %f" mu K c alpha p
gets $fp line
scan $line "%d %d %d %d %d" fix_mu fix_K fix_c fix_alpha fix_p
gets $fp line
scan $line "%f" aic2
gets $fp line
scan $line "%f" Zte
gets $fp line
scan $line "%f" gradient
close $fp
set aic2 [format "%6g" $aic2]
set gradient [format "%6g" $gradient]

set init_Zts $Zts
set init_tend $tend
set init_tstart $tstart
set init_Zte $Zte

set init_mu $mu
set init_K  $K
set init_c  $c
set init_alpha $alpha
set init_p $p

proc syncPRM { PRMfile } {
    global Mc
#   global AA
#   set fp [open $AAfile r]
#   while {![eof $fp]} {
#     gets $fp line
#     scan $line "%s %s" key value
#     set AA($key) $value
#  }
#  close $fp
   set Mc 0.0
}

proc syncTM { } {
    global Zts
    global tstart
    global Zte
    global tend
    set fp [open etas.time r]
    gets $fp line
    scan $line "%f %f %f %f" Zts tstart Zte tend
    close $fp
}

proc updata {} {
    global Mc
    global Mz
    global tstart
    global tend
    global Zts
    global Zte
    global mu
    global K
    global c
    global alpha
    global p
    global fix_mu
    global fix_K
    global fix_c
    global fix_alpha
    global fix_p
    global aic2
    global aic2_1
    global aic2_2
    global aic2_12
    global aic2_diff
    global aic2_3
    global gradient
    global setting
    set file etas.out
    set fp [open $file r]
    gets $fp line
    gets $fp line
    scan $line "%f %f %f" Zts tend tstart
    gets $fp line
    scan $line "%f %f" Mc Mz
    gets $fp line
    scan $line "%f %f %f %f %f" mu K c alpha p
    gets $fp line
    scan $line "%d %d %d %d %d" fix_mu fix_K fix_c fix_alpha fix_p
    gets $fp line
    scan $line "%f" aic2
    gets $fp line
    scan $line "%f" Zte
    gets $fp line
    scan $line "%f" gradient
    set mu [format "%-12g" $mu]
    set K [format "%-12g" $K]
    set c [format "%-12g" $c]
    set alpha [format "%-12g" $alpha]
    set p [format "%-12g" $p]
    set aic2 [format "%6g" $aic2]
    set gradient [format "%6g" $gradient]
    close $fp
    if { $setting == 1 }  { set aic2_1 [format "%6g" $aic2] }
    if { $setting == 2 }  { set aic2_2 [format "%6g" $aic2] }
    if { $setting == 3 }  { set aic2_3 [format "%6g" $aic2] }
    set aic2_12 [format "%6g" [expr $aic2_1+$aic2_2]]
    set aic2_diff [format "%6g" [expr $aic2_1+$aic2_2-$aic2_3]]
#
    wlog
#
}

proc updata2 {} {
    global Mc
    global Mz
    global tstart
    global tend
    global Zts
    global Zte
    global mu
    global K
    global c
    global alpha
    global p
    global fix_mu
    global fix_K
    global fix_c
    global fix_alpha
    global fix_p
    global aic2
    global gradient
    set file etas.open
    set fp [open $file r]
    gets $fp line
    gets $fp line
    scan $line "%f %f %f %f" Zts Zte tstart tend
    gets $fp line
    scan $line "%f %f" Mc Mz
    gets $fp line
    scan $line "%f %f %f %f %f" mu K c alpha p
    gets $fp line
    scan $line "%d %d %d %d %d" fix_mu fix_K fix_c fix_alpha fix_p
    set mu [format "%-12g" $mu]
    set K [format "%-12g" $K]
    set c [format "%-12g" $c]
    set alpha [format "%-12g" $alpha]
    set p [format "%-12g" $p]
    close $fp
}


proc wlog {} {
    global Mc
    global Mz
    global tstart
    global tend
    global Zts
    global Zte
    global mu
    global K
    global c
    global alpha
    global p
    global fix_mu
    global fix_K
    global fix_c
    global fix_alpha
    global fix_p
    global aic2
    global gradient
    global memo
    global env
    set file etas.log.new
    set fp [open $file w]
    puts $fp "9  4"
    puts $fp "$Zts $Zte $tstart $tend"
    puts $fp "$Mc $Mz";
    puts $fp "$mu $K $c $alpha $p";
    puts $fp "$fix_mu $fix_K $fix_c $fix_alpha $fix_p";
    set chtm [clock format [clock seconds] -format {%Y/%m/%d (%a) %H:%M:%S}]
    puts $fp [format "==== %s ==== %s" $memo $chtm]
    set fix0 [format "%1d%1d%1d%1d%1d" $fix_mu $fix_K $fix_c $fix_alpha $fix_p]
    puts $fp "ETASX.sh Mth=$Mc Mz=$Mz zts=$Zts tstart=$tstart zte=$Zte tend=$tend mu=$mu K=$K c=$c alpha=$alpha p=$p fix=$fix0"
#    puts $fp [format "Mc:%f Mz:%f" $Mc $Mz]
#    puts $fp [format "zts:%f tstart:%f zte:%f tend:%f" $Zts $tstart $Zte $tend]
#    puts $fp [format "mu:%f K:%f c:%f alpha:%f p:%f" $mu $K $c $alpha $p]
#    puts $fp [format "fix_mu:%d fix_K:%d fix_c:%d fix_alpha:%d fix_p:%d" $fix_mu $fix_K $fix_c $fix_alpha $fix_p]
    puts $fp [format "aic/2:%f gradient:%f\n" $aic2 $gradient]
    close $fp
    exec $env(ETAS_HOME)/bin/mklog.sh
}

proc fmtPRM {} {
    global Mc
    global Mz
    global tstart
    global tend
    global Zts
    global Zte
    global mu
    global K
    global c
    global alpha
    global p
    global fix_mu
    global fix_K
    global fix_c
    global fix_alpha
    global fix_p
    global fix
    global aic2
    global gradient
    set fix [format "%1d%1d%1d%1d%1d" $fix_mu $fix_K $fix_c $fix_alpha $fix_p]
    set Mc [format "%-f" $Mc]
    set Mz [format "%-f" $Mz]
    set Zts [format "%-f" $Zts]
    set Zte [format "%-f" $Zte]
    set tstart [format "%-f" $tstart]
    set tend [format "%-f" $tend]
    set mu [format "%-12g" $mu]
    set K [format "%-12g" $K]
    set c [format "%-12g" $c]
    set alpha [format "%-12g" $alpha]
    set p [format "%-12g" $p]
}

proc ChangeTimeAnalysis { plot } {
    global env
    global setting
    global Mc
    global Mz
    global tstart
    global tend
    global Zts
    global Zte
    global tstart0
    global tend0
    global Zts0
    global Zte0
    global mu
    global K
    global c
    global alpha
    global p
    global fix_mu
    global fix_K
    global fix_c
    global fix_alpha
    global fix_p
    global winscale
    global optPLTmax
    global optLOG

# backup parameters
    set bk_Zts $Zts; set bk_tstart $tstart; set bk_tend $tend; set bk_Zte $Zte 
    set bk_mu $mu; set bk_K $K; set bk_c $c; set bk_alpha $alpha; set bk_p $p

    set wx0 20.0
    set wy0 20.0
    set fix [format "%1d%1d%1d%1d%1d" $fix_mu $fix_K $fix_c $fix_alpha $fix_p]
#
    set setting 3
    set fp [open _run.sh w];
    set cmd "$env(ETAS_HOME)/bin/ETASX.sh Mth=$Mc Mz=$Mz tstart=$tstart0 tend=$tend0 zts=$Zts0 zte=$tend0 mu=$mu K=$K c=$c alpha=$alpha p=$p fix=$fix 2>&1"
    puts $fp $cmd
    set cmd "exec $env(ETAS_HOME)/bin/etasplot -n$optLOG -w10 -octa3.ps"
    puts $fp $cmd
    close $fp
    puts $cmd
    exec sh _run.sh
#    after 500; updata; after 500
    exec $env(ETAS_HOME)/bin/$plot -n$optLOG -t$optPLTmax -w0 -s$winscale -x$wx0 -y$wy0 &
    updata; after 500;
#
    set wx0 [expr $wx0 + 10.0]
    set wy0 [expr $wy0 + 10.0]
    set setting 1
    set fp [open _run.sh w];
    set cmd "$env(ETAS_HOME)/bin/ETASX.sh -Q Mth=$Mc Mz=$Mz tstart=$tstart0 tend=$tend0 zts=$Zts0 zte=$Zte0 mu=$mu K=$K c=$c alpha=$alpha p=$p fix=$fix 2>&1"
    puts $fp $cmd
    set cmd "exec $env(ETAS_HOME)/bin/etasplot -n$optLOG -w10 -octa1.ps"
    puts $fp $cmd
    close $fp
    puts $cmd
    exec sh _run.sh
#    after 500; updata; after 500
    exec $env(ETAS_HOME)/bin/$plot -n$optLOG -t$optPLTmax -w0 -s$winscale -x$wx0 -y$wy0 &
    updata; after 500;
#
    set Zts $bk_Zts; set tstart $bk_tstart; set tend $bk_tend; set Zte $bk_Zte 
    set mu $bk_mu; set K $bk_K; set c $bk_c; set alpha $bk_alpha; set p $bk_p
    set wx0 [expr $wx0 + 10.0]
    set wy0 [expr $wy0 + 10.0]
    set setting 2
    set fp [open _run.sh w];
    set cmd "$env(ETAS_HOME)/bin/ETASX.sh -Q Mth=$Mc Mz=$Mz tstart=$Zte0 tend=$tend0 zts=$Zts0 zte=$tend0 mu=$mu K=$K c=$c alpha=$alpha p=$p fix=$fix 2>&1"
    puts $fp $cmd
    set cmd "exec $env(ETAS_HOME)/bin/etasplot -n$optLOG -w10 -octa2.ps"
    puts $fp $cmd
    close $fp
    puts $cmd
    exec sh _run.sh
#    after 500; updata; after 500
    exec $env(ETAS_HOME)/bin/$plot -n$optLOG -t$optPLTmax -w0 -s$winscale -x$wx0 -y$wy0 &
    updata; after 500;
#
# restore parameters
    set Zts $bk_Zts; set tstart $bk_tstart; set tend $bk_tend; set Zte $bk_Zte 
    set mu $bk_mu; set K $bk_K; set c $bk_c; set alpha $bk_alpha; set p $bk_p
}

proc pr_conf {} {
  global ps_mf
  global ps_np
  global ps_xy_n0
  global ps_z_n0
  global ps_xy_n1
  global ps_z_n1
  global ps_hypo
  global ps_mon
  global ps_monx
  global ps_label
  global ps_pdf
  set parx [expr [winfo rootx .] + 130]
  set pary [expr [winfo rooty .] + 30]
  toplevel .ps
  wm title .ps "Plot Configration"
  wm geometry .ps "+$parx+$pary"
  frame .ps.mf
  label .ps.mf.label -text "Magnitude Frequency:"
  checkbutton .ps.mf.on -text "On" -variable ps_mf
  pack .ps.mf.label .ps.mf.on -side left
  frame .ps.np
  label .ps.np.label -text "ETAS Fit:"
  checkbutton .ps.np.on -text "On" -variable ps_np
  pack .ps.np.label .ps.np.on -side left
  frame .ps.xy
  label .ps.xy.label -text "XY (transformed time):"
  checkbutton .ps.xy.on -text "On" -variable ps_xy_n0
  pack .ps.xy.label .ps.xy.on -side left
  frame .ps.z
  label .ps.z.label -text "Z (transformed time):"
  checkbutton .ps.z.on -text "On" -variable ps_z_n0
  pack .ps.z.label .ps.z.on -side left
  frame .ps.xy2
  label .ps.xy2.label -text "XY (ordinary time):"
  checkbutton .ps.xy2.on -text "On" -variable ps_xy_n1
  pack .ps.xy2.label .ps.xy2.on -side left
  frame .ps.z2
  label .ps.z2.label -text "Z (ordinary time):"
  checkbutton .ps.z2.on -text "On" -variable ps_z_n1
  pack .ps.z2.label .ps.z2.on -side left
  frame .ps.hypo
  label .ps.hypo.label -text "Hypocenter:"
  checkbutton .ps.hypo.on -text "On" -variable ps_hypo
  pack .ps.hypo.label .ps.hypo.on -side left
  frame .ps.mon
  label .ps.mon.label -text "Mon:"
  checkbutton .ps.mon.on -text "On" -variable ps_mon
  pack .ps.mon.label .ps.mon.on -side left
  frame .ps.monx
  label .ps.monx.label -text "MonX:"
  checkbutton .ps.monx.on -text "On" -variable ps_monx
  pack .ps.monx.label .ps.monx.on -side left
  frame .ps.label
  label .ps.label.label -text "Label:"
  entry .ps.label.entry -textvariable ps_label -width 20
  pack .ps.label.label .ps.label.entry -side left
  button .ps.all -text "All" -command {set ps_mf 1; set ps_np 1; set ps_xy_n0 1; set ps_z_n0 1; set ps_xy_n1 1; set ps_z_n1 1; set ps_hypo 1; set ps_mon 1; set ps_monx 1;}
  button .ps.none -text "None" -command {set ps_mf 0; set ps_np 0; set ps_xy_n0 0; set ps_z_n0 0; set ps_xy_n1 0; set ps_z_n1 0; set ps_hypo 0; set ps_mon 0; set ps_monx 0;}
  frame .ps.pdf
  label .ps.pdf.label -text "PDF:"
  checkbutton .ps.pdf.on -text "On" -variable ps_pdf
  pack .ps.pdf.label .ps.pdf.on -side left
  button .ps.close -text "Close"  -command {destroy .ps}
#  pack .ps.mf .ps.np .ps.xy .ps.z .ps.xy2 .ps.z2 .ps.hypo .ps.mon .ps.monx .ps.label .ps.all .ps.none .ps.close -side top
  pack .ps.mf .ps.np .ps.xy .ps.z .ps.xy2 .ps.z2 .ps.hypo .ps.mon .ps.monx .ps.pdf .ps.all .ps.none .ps.close -side top
}


proc cta_win {} {
    global env
    global setting
    global Mc
    global Mz
    global tstart
    global tend
    global Zts
    global Zte
    global tstart0
    global tend0
    global Zts0
    global Zte0
    global mu
    global K
    global c
    global alpha
    global p
    global fix_mu
    global fix_K
    global fix_c
    global fix_alpha
    global fix_p
    global winscale
    global optPLTmax
    set fix [format "%1d%1d%1d%1d%1d" $fix_mu $fix_K $fix_c $fix_alpha $fix_p]
  set Zts0 $Zts 
  set Zte0 $Zte
  set tstart0 $tstart
  set tend0 $tend
  set parx [expr [winfo rootx .] + 130]
  set pary [expr [winfo rooty .] + 30]
  toplevel .ct
  wm title .ct "Change Time Analysis"
  wm geometry .ct "+$parx+$pary"
  frame .ct.ts
  label .ct.ts.label -text " tstart:"
  entry .ct.ts.entry -textvariable tstart0 -width 15
  pack .ct.ts.label .ct.ts.entry -side left
  frame .ct.te
  label .ct.te.label -text " tend:"
  entry .ct.te.entry -textvariable tend0 -width 15
  pack .ct.te.label .ct.te.entry -side left
  frame .ct.zts
  label .ct.zts.label -text " Zts:"
  entry .ct.zts.entry -textvariable Zts0 -width 15
  pack .ct.zts.label .ct.zts.entry -side left
  frame .ct.zte
  label .ct.zte.label -text " Zte:"
  entry .ct.zte.entry -textvariable Zte0 -width 15
  pack .ct.zte.label .ct.zte.entry -side left
  frame .ct.runx1
  label .ct.runx1.label -text "Fit(1): "
  button .ct.runx1.set -text "tstart Zte" -command {set setting 1;fmtPRM; exec $env(ETAS_HOME)/bin/ETASX.sh -Q Mth=$Mc Mz=$Mz tstart=$tstart0 tend=$tend0 zts=$Zts0 zte=$Zte0 mu=$mu K=$K c=$c alpha=$alpha p=$p fix=$fix &}
  label .ct.runx1.label1 -text "aic/2: "
  entry .ct.runx1.entry1 -textvariable aic2_1 -width 8
  pack .ct.runx1.label .ct.runx1.set .ct.runx1.label1 .ct.runx1.entry1 -side left
  frame .ct.runx2
  label .ct.runx2.label -text "Fit(2): "
  button .ct.runx2.set -text "Zte tend" -command {set setting 2;fmtPRM; exec $env(ETAS_HOME)/bin/ETASX.sh -Q Mth=$Mc Mz=$Mz tstart=$Zte0 tend=$tend0 zts=$Zts0 zte=$tend0 mu=$mu K=$K c=$c alpha=$alpha p=$p fix=$fix &}
  label .ct.runx2.label1 -text "aic/2: "
  entry .ct.runx2.entry1 -textvariable aic2_2 -width 8
  pack .ct.runx2.label .ct.runx2.set .ct.runx2.label1 .ct.runx2.entry1 -side left
  frame .ct.runx12
  label .ct.runx12.label1 -text "aic/2 (1+2)-(all):"
  entry .ct.runx12.entry1 -textvariable aic2_diff -width 8
  label .ct.runx12.label2 -text "(1+2):"
  entry .ct.runx12.entry2 -textvariable aic2_12 -width 8
  pack .ct.runx12.label1 .ct.runx12.entry1 .ct.runx12.label2 .ct.runx12.entry2 -side left
  frame .ct.runx3
  label .ct.runx3.label -text "Fit(all): "
  button .ct.runx3.set -text "tstart tend" -command {set setting 3;fmtPRM; exec $env(ETAS_HOME)/bin/ETASX.sh Mth=$Mc Mz=$Mz tstart=$tstart0 tend=$tend0 zts=$Zts0 zte=$tend0 mu=$mu K=$K c=$c alpha=$alpha p=$p fix=$fix &}
  label .ct.runx3.label1 -text "aic/2: "
  entry .ct.runx3.entry1 -textvariable aic2_3 -width 8
  pack .ct.runx3.label .ct.runx3.set .ct.runx3.label1 .ct.runx3.entry1 -side left
  frame .ct.run
  label .ct.run.label1 -text "  Run:  " -bg #000033 -fg yellow
  button .ct.run.etas -text " ETAS " -command {ChangeTimeAnalysis etasplot}
  label .ct.run.label2 -text "Plot: "
  button .ct.run.plot -text " X " -command {if { [file exists etas.lock] == 1 } then {puts "ETAS is now running" } else {updata; exec $env(ETAS_HOME)/bin/etasplot -n$optLOG -t$optPLTmax -w0 -s$winscale &} }
  pack .ct.run.label1 .ct.run.etas .ct.run.label2 .ct.run.plot -side left
  button .ct.close -text "Close"  -command {destroy .ct}
  pack .ct.zts .ct.ts .ct.zte .ct.te .ct.runx1 .ct.runx2 .ct.runx12 .ct.runx3 .ct.run .ct.close -side top
}

#### MAIN 

wm title . "ETAS Control Panel"
wm geometry . +25+35
wm resizable . 0 0

frame .hypo
frame .xetas
button .xetas.run -text "Run xetas.sh" -command {set ret [exec $env(ETAS_HOME)/bin/xetas2.sh &]}
#button .xetas.cta -text "Change Time Analysis" -command { cta_win }
button .xetas.cta -text "Change Time Analysis" -command {exec $env(ETAS_HOME)/bin/xetasct.sh &}
pack .xetas.run .xetas.cta -side left
#frame .zero
frame .mc
frame .mz
frame .ts
frame .te
frame .zts
frame .zte
frame .tm
label .tm.label -text "Time Parameters (Zts, tstart, Zte, tend):"
button .tm.graph -text "Graph" -command {exec $env(ETAS_HOME)/bin/etastmplot -w0 -s$winscale; syncTM}
button .tm.init -text "Reset" -command {set Zts $init_Zts; set tstart $init_tstart; set tend $init_tend; set Zte $init_Zte;}
label .tm.label1 -text "  "
#button .tm.reset -text "Reset Parameters" -command {set Zts $init_Zts; set tstart $init_tstart; set tend $init_tend; set Zte $init_Zte; set mu $init_mu; set K $init_K; set c $init_c; set alpha $init_alpha; set p $init_p}
pack .tm.label .tm.graph .tm.init .tm.label1 -side left
frame .param
label .param.label -text "ETAS Parameters (mu, K, c, alpha, p):"
button .param.reset -text "Reset" -command {set mu $init_mu; set K $init_K; set c $init_c; set alpha $init_alpha; set p $init_p; set fix_mu 0; set fix_K 0; set fix_c 0; set fix_alpha 0; set fix_p 0}
pack .param.label .param.reset -side left
frame .mu
frame .k
frame .c
frame .alpha
frame .p
frame .run
label .run.label -text "  Run:  " -bg #000033 -fg yellow
button .run.etas -text " ETAS " -command {
    if { $alpha == 0.0 } { set alpha 1.2 }; 
    if { $Zte > $tend } { set Zte $tend};
    if { $Zts > $tstart } { set tstart [expr $Zts+0.01] };
    set setting 0;
    fmtPRM; 
    exec $env(ETAS_HOME)/bin/ETASX.sh -Q Mth=$Mc Mz=$Mz tstart=$tstart tend=$tend zts=$Zts zte=$Zte mu=$mu K=$K c=$c alpha=$alpha p=$p fix=$fix &
}
button .run.aftpoi -text " AFTPOI " -command {set setting 0;fmtPRM; exec $env(ETAS_HOME)/bin/ETASX.sh -A Mth=$Mc Mz=$Mz tstart=$tstart tend=$tend zts=$Zts zte=$Zte mu=$mu K=$K c=$c alpha=$alpha p=$p fix=$fix &}
button .run.etasim -text " ETASIM " -command {exec $env(ETAS_HOME)/bin/xetasim.sh &}
pack .run.label .run.etas .run.aftpoi .run.etasim -side left
frame .result
frame .plot
label .plot.label -text "Plot: "
button .plot.disp -text " TM " -command {if { [file exists etas.lock] == 1 } then {puts "ETAS is now running" } else {updata; exec $env(ETAS_HOME)/bin/etasplot -n$optLOG -t$optPLTmax -w0 -s$winscale &} }
button .plot.xy -text " XY " -command {if { [file exists etas.lock] == 1 } then {puts "ETAS is now running" } else {updata; exec $env(ETAS_HOME)/bin/etasxyplot -n$optNTM -w0 -s$winscale &} }
button .plot.z -text " Z " -command {if { [file exists etas.lock] == 1 } then {puts "ETAS is now running" } else {updata; exec $env(ETAS_HOME)/bin/etaszplot -n$optNTM -w0 -s$winscale &} }
button .plot.hypo -text " HYPO " -command {if { [file exists etas.lock] == 1 } then {puts "ETAS is now running" } else {updata; exec $env(ETAS_HOME)/bin/etashypo -w0 -s$winscale &} }
checkbutton .plot.ntm -text "ordinary time" -variable optNTM
#checkbutton .plot.log10 -text "log" -variable optLOG
#label .plot.label1 -text " win size: "
#entry .plot.entry -textvariable winscale -width 4
#button .plot.up -text " + " -command {set winscale [expr $winscale + 0.1]; set winscale [format "%.1f" $winscale]}
#button .plot.down -text " - " -command {set winscale [expr $winscale - 0.1]; if { $winscale < 0.05 } then { set winscale 0.1 }; set winscale [format "%.1f" $winscale]}
#pack .plot.label .plot.disp .plot.xy .plot.z .plot.hypo .plot.label1 .plot.entry .plot.up .plot.down -side left
#pack .plot.label .plot.disp .plot.xy .plot.z .plot.ntm .plot.log10 .plot.hypo -side left
pack .plot.label .plot.disp .plot.xy .plot.z .plot.ntm .plot.hypo -side left

frame .mon
label .mon.label -text "Mon: "
button .mon.plot -text " V " -command {if { [file exists etas.lock] == 1 } then {puts "ETAS is now running" } else {updata; exec $env(ETAS_HOME)/bin/etasmon -t$optPLTmax -w0 -s$winscale -h$h -a$amax0 &} }
label .mon.label1 -text " H: "
entry .mon.entry -textvariable h -width 3
button .mon.up -text "+" -command {set h [expr $h + 1]; set h [format "%d" $h]}
button .mon.down -text "-" -command {set h [expr $h - 1]; if { $h < 1 } then { set h 1 }; set h [format "%d" $h]}
label .mon.labelA -text " A: "
entry .mon.entryA -textvariable amax0 -width 5
button .mon.upA -text "+" -command {set amax0 [expr $amax0 + 0.5]; set amax0 [format "%3.1f" $amax0]}
button .mon.downA -text "-" -command {set amax0 [expr $amax0 - 0.5]; if { $amax0 < 1 } then { set amax0 1 }; set amax0 [format "%3.1f" $amax0]}
pack .mon.label .mon.label1 .mon.entry .mon.up .mon.down .mon.labelA .mon.entryA .mon.upA .mon.downA .mon.plot -side left

frame .monx
label .monx.label -text "MonX: "
button .monx.plot -text " V " -command {if { [file exists etas.lock] == 1 } then {puts "ETAS is now running" } else {updata; exec $env(ETAS_HOME)/bin/etasmonx -t$optPLTmax -w0 -s$winscale -h$h1/$h2 -a$amaxx0 &} }
label .monx.label1 -text " H1: "
entry .monx.entry1 -textvariable h1 -width 3
label .monx.label2 -text " H2: "
entry .monx.entry2 -textvariable h2 -width 3
label .monx.labelA -text " A: "
entry .monx.entryA -textvariable amaxx0 -width 5
button .monx.upA -text "+" -command {set amaxx0 [expr $amaxx0 + 0.5]; set amaxx0 [format "%3.1f" $amaxx0]}
button .monx.downA -text "-" -command {set amaxx0 [expr $amaxx0 - 0.5]; if { $amaxx0 < 1 } then { set amaxx0 1 }; set amaxx0 [format "%3.1f" $amaxx0]}
pack .monx.label .monx.label1 .monx.entry1 .monx.label2 .monx.entry2 .monx.labelA .monx.entryA .monx.upA .monx.downA .monx.plot -side left

frame .option
label .option.label -text "Win Size: "
entry .option.entry -textvariable winscale -width 4
button .option.up -text " + " -command {set winscale [expr $winscale + 0.1]; set winscale [format "%.1f" $winscale]}
button .option.down -text " - " -command {set winscale [expr $winscale - 0.1]; if { $winscale < 0.05 } then { set winscale 0.1 }; set winscale [format "%.1f" $winscale]}
label .option.label1 -text "max: "
radiobutton .option.plotauto -text "auto" -variable optPLTmax -value 0
radiobutton .option.plotobs -text "obs" -variable optPLTmax -value 1
radiobutton .option.plotsyn -text "syn" -variable optPLTmax -value 2
pack .option.label .option.entry .option.up .option.down .option.label1 .option.plotauto .option.plotobs .option.plotsyn -side left

frame .postscript
frame .memo
button .quit -text "Quit" -command {exec $env(ETAS_HOME)/bin/kill_plot.sh; exit}
#pack .hypo .xetas .zero .mc .mz .zts .ts .zte .te .tm .mu .k .c .alpha .p .run .plot .mon .postscript .result .memo .quit -side top
pack .hypo .xetas .mc .mz .zts .ts .zte .te .tm .param .mu .k .c .alpha .p .run .plot .mon .monx .option .postscript .result .memo .quit -side top

label .hypo.label -text " Catalog:" -bg #000033 -fg yellow
#entry .hypo.entry -textvariable hypo -width 15
label .hypo.entry -textvariable hypo -width 15
pack .hypo.label .hypo.entry -side left

label .mc.label -text " Mc:"
entry .mc.entry -textvariable Mc -width 5
button .mc.up -text " + " -command {set Mc [expr $Mc + 0.1]; set Mc [format "%.1f" $Mc]; set K [expr 0.81283*$K]}
button .mc.down -text " - " -command {set Mc [expr $Mc - 0.1]; set Mc [format "%.1f" $Mc]; set K [expr 1.23027*$K]}
button .mc.plot -text "Magnitude Frequency" -command {exec $env(ETAS_HOME)/bin/etasxmf -w0 -s$winscale &;}
pack .mc.label .mc.entry .mc.up .mc.down .mc.plot -side left

label .mz.label -text " Mz:"
entry .mz.entry -textvariable Mz -width 15
pack .mz.label .mz.entry -side left

label .ts.label -text " tstart:"
entry .ts.entry -textvariable tstart -width 15
pack .ts.label .ts.entry -side left

label .te.label -text " tend:"
entry .te.entry -textvariable tend -width 15
pack .te.label .te.entry -side left

label .zts.label -text " Zts:"
entry .zts.entry -textvariable Zts -width 15
pack .zts.label .zts.entry -side left

label .zte.label -text " Zte:"
entry .zte.entry -textvariable Zte -width 15
pack .zte.label .zte.entry -side left

label .mu.label -text " mu:"
entry .mu.entry -textvariable mu -width 15
button .mu.zero -text "mu=0" -command {set mu 0.0; set fix_mu 1}
button .mu.notzero -text "mu>0" -command {set mu 0.5}
label .mu.fixlabel -text "Fix:"
checkbutton .mu.fixon -text "" -variable fix_mu
pack .mu.label .mu.entry .mu.zero .mu.notzero .mu.fixlabel .mu.fixon -side left

label .k.label -text " K:"
entry .k.entry -textvariable K -width 15
button .k.zero -text "K=0" -command {set K 0.0; set fix_K 1; set fix_c 1; set fix_alpha 1; set fix_p 1;}
label .k.fixlabel -text "Fix:"
checkbutton .k.fixon -text "" -variable fix_K
pack .k.label .k.entry .k.zero .k.fixlabel .k.fixon -side left

label .c.label -text " c:"
entry .c.entry -textvariable c -width 15
label .c.fixlabel -text "Fix:"
checkbutton .c.fixon -text "" -variable fix_c
pack .c.label .c.entry .c.fixlabel .c.fixon -side left

label .alpha.label -text " alpha:"
entry .alpha.entry -textvariable alpha -width 15
button .alpha.button -text "alpha>1.0" -command {set alpha 1.2}
label .alpha.fixlabel -text "Fix:"
checkbutton .alpha.fixon -text "" -variable fix_alpha
pack .alpha.label .alpha.entry .alpha.button .alpha.fixlabel .alpha.fixon -side left

label .p.label -text " p:"
entry .p.entry -textvariable p -width 15
button .p.one -text "p=1" -command {set p 1.0; set fix_p 1}
button .p.gtone -text "p>1.0" -command {set p 1.2}
label .p.fixlabel -text "Fix:"
checkbutton .p.fixon -text "" -variable fix_p
pack .p.label .p.entry .p.one .p.gtone .p.fixlabel .p.fixon -side left

#label .plot.label -text "Plot: "

#button .plot.disp -text "X-Window" -command {if { [file exists etas.lock] == 1 } then {puts "ETAS is now running" } else {updata; exec $env(ETAS_HOME)/bin/etasplot -n$optLOG -t$optPLTmax -w0 -s$winscale &} }
#pack .plot.label .plot.disp -side left

label .postscript.label -text "PostScript: "
label .postscript.label2 -text "suffix:"
entry .postscript.filename -textvariable suffix -width 8
button .postscript.output -text "Output" -command {
if { [file exists etas.lock] == 1 } then {puts "ETAS is now running" } else {
  updata;
  if { $ps_np } {
     set psfile [format "etastm%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etasplot -n$optLOG -t$optPLTmax -w10 -o$psfile &;
  }
  if { $ps_xy_n0 } {
     set psfile [format "etasxy%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etasxyplot -w10 -o$psfile &;
  }
  if { $ps_xy_n1 } {
     set psfile [format "etasxyn1%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etasxyplot -n1 -w10 -o$psfile &;
  }
  if { $ps_z_n0 } {
     set psfile [format "etasz%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etaszplot -w10 -o$psfile &;
  }
  if { $ps_z_n1 } {
     set psfile [format "etaszn1%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etaszplot -n1 -w10 -o$psfile &;
  }
  if { $ps_hypo } {
    set psfile [format "etashypo%s.ps" $suffix];
    puts "output $psfile"
    exec $env(ETAS_HOME)/bin/etashypo -w10 -o$psfile &;
  }
  if { $ps_mon } {
     set psfile [format "etasmon%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etasmon -t$optPLTmax -w10 -o$psfile -h$h -a$amax0&;
  }
  if { $ps_monx } {
    set psfile [format "etasmonx%s.ps" $suffix];
    puts "output $psfile"
    exec $env(ETAS_HOME)/bin/etasmonx -t$optPLTmax -w10 -o$psfile -h$h1/$h2 -a$amaxx0 &;
  }
  if { $ps_mf } {
    set psfile [format "etasmf%s.ps" $suffix];
    puts "output $psfile"
    exec $env(ETAS_HOME)/bin/etasxmf -w10 -o$psfile &;
  }
  if { $ps_pdf } {
    set pdffile [format "etas%s.pdf" $suffix];
    puts "output $pdffile"
    exec $env(ETAS_HOME)/bin/merge_ps.sh $pdffile &;
  }
 } 
}
button .postscript.outall -text "All" -command {
if { [file exists etas.lock] == 1 } then {puts "ETAS is now running" } else {
  updata;
     set psfile [format "etastm%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etasplot -n$optLOG -t$optPLTmax -w10 -o$psfile &;
     set psfile [format "etasxy%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etasxyplot -w10 -o$psfile &;
     set psfile [format "etasxyn1%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etasxyplot -n1 -w10 -o$psfile &;
     set psfile [format "etasz%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etaszplot -w10 -o$psfile &;
     set psfile [format "etaszn1%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etaszplot -n1 -w10 -o$psfile &;
    set psfile [format "etashypo%s.ps" $suffix];
    puts "output $psfile"
    exec $env(ETAS_HOME)/bin/etashypo -w10 -o$psfile &;
     set psfile [format "etasmon%s.ps" $suffix];
     puts "output $psfile"
     exec $env(ETAS_HOME)/bin/etasmon -t$optPLTmax -w10 -o$psfile -h$h -a$amax0 &;
    set psfile [format "etasmonx%s.ps" $suffix];
    puts "output $psfile"
    exec $env(ETAS_HOME)/bin/etasmonx -t$optPLTmax -w10 -o$psfile -h$h1/$h2 -a$amaxx0 &;
    set psfile [format "etasmf%s.ps" $suffix];
    puts "output $psfile"
    exec $env(ETAS_HOME)/bin/etasxmf -w10 -o$psfile &;
    if { $ps_pdf } {
      set pdffile [format "etas%s.pdf" $suffix];
      puts "output $pdffile"
      exec $env(ETAS_HOME)/bin/merge_ps.sh $pdffile &;
    }
 } 
}
button .postscript.conf -text "CF" -command { pr_conf };
pack .postscript.label .postscript.label2 .postscript.filename .postscript.conf .postscript.outall .postscript.output -side left

label .result.label1 -text "aic/2: "
entry .result.entry1 -textvariable aic2 -width 10
label .result.label2 -text "gradient: "
entry .result.entry2 -textvariable gradient -width 12
pack .result.label1 .result.entry1 .result.label2 .result.entry2 -side left

#label .resultx.label1 -text "1: "
#entry .resultx.entry1 -textvariable aic2_1 -width 8
#label .resultx.label2 -text "2: "
#entry .resultx.entry2 -textvariable aic2_2 -width 8
#label .resultx.label12 -text "1+2: "
#entry .resultx.entry12 -textvariable aic2_12 -width 8
#label .resultx.label3 -text "all: "
#entry .resultx.entry3 -textvariable aic2_3 -width 8
#pack .resultx.label1 .resultx.entry1 .resultx.label2 .resultx.entry2 .resultx.label12 .resultx.entry12 .resultx.label3 .resultx.entry3 -side left


label .memo.label -text "Memo: "
entry .memo.entry -textvariable memo -width 20
button .memo.log -text "Write Log" -command {wlog}
pack .memo.label .memo.entry .memo.log -side left

##label .zero.label -text "Reference Time:"
##entry .zero.entry -textvariable t0 -width 25
#button .zero.conv -text "Change" -command {scan $t0 "%d %d %d %d %d %f" $yr0 $mo0 $dy0 $hr0 $mi0 $sc0; puts "exec $env(ETAS_HOME)/bin/tseis2etas $t0 < $hypo > work.etas"; set kekka [exec $env(ETAS_HOME)/bin/tseis2etas $yr0 $mo0 $dy0 $hr0 $mi0 $sc0 < $hypo > work.etas]; puts $kekka}
##button .zero.conv -text "Change" -command {set fp [open _conv.sh w]; puts $fp "$env(ETAS_HOME)/bin/tseis2etas $t0 < $hypo > work.etas"; close $fp; exec sh _conv.sh}
##pack .zero.label .zero.entry .zero.conv -side left
