#!/usr/bin/wish


set DIR [lindex $argv 0]
set ic 0
set dT 0.5
set iplotx 1
set cplotx ""
set ioutput 1
set coutput ""
set xmin 1.0
set xmax 5.0
set ymin -5.0
set ymax 5.0

set file etas.out
set fp [open $file r]
gets $fp line
gets $fp line
scan $line "%f %f %f" Zts tend tstart
gets $fp line
scan $line "%f %f" Mc Mz
gets $fp line
scan $line "%f %f %f %f %f" mu K c alpha p
gets $fp line
scan $line "%d %d %d %d %d" fix_mu fix_K fix_c fix_alpha fix_p
gets $fp line
scan $line "%f" aic2
gets $fp line
scan $line "%f" Zte
gets $fp line
scan $line "%f" gradient
close $fp
set aic2 [format "%6g" $aic2]
set gradient [format "%6g" $gradient]

set init_Zts $Zts
set init_tend $tend
set init_tstart $tstart
set init_Zte $Zte

set init_mu $mu
set init_K  $K
set init_c  $c
set init_alpha $alpha
set init_p $p

set CT1 [expr ($tstart+$tend)/2.0]
set CT2 $CT1
set CT1 [format "%.0f" $CT1]
set CT2 [format "%.0f" $CT2]

# MAIN
wm title . "ETASCT Control Panel"
wm geometry . +5+15
wm resizable . 0 0

frame .dir
label .dir.label -text " Dir:"
label .dir.entry -textvariable DIR -width 12
pack .dir.label .dir.entry -side left

frame .ct1
label .ct1.label -text " CT1:" 
entry .ct1.entry -textvariable CT1 -width 8
pack .ct1.label .ct1.entry -side left

frame .ct2
label .ct2.label -text " CT2:" 
entry .ct2.entry -textvariable CT2 -width 8
pack .ct2.label .ct2.entry -side left

frame .ic
label .ic.label -text "Change Time Series:"
radiobutton .ic.work -text "work.etas" -variable ic -value 1
radiobutton .ic.dt -text "dT" -variable ic -value 0
pack .ic.label .ic.work .ic.dt -side top

frame .dt
label .dt.label -text " dT:" 
entry .dt.entry -textvariable dT -width 8
pack .dt.label .dt.entry -side left

frame .mc
label .mc.label -text " Mc:"
entry .mc.entry -textvariable Mc -width 5
pack .mc.label .mc.entry -side left

frame .mz
label .mz.label -text " Mz:"
entry .mz.entry -textvariable Mz -width 5
pack .mz.label .mz.entry -side left

frame .zts
label .zts.label -text " Zts:"
entry .zts.entry -textvariable Zts -width 8
pack .zts.label .zts.entry -side left

frame .ts
label .ts.label -text " tsart:"
entry .ts.entry -textvariable tstart -width 8
pack .ts.label .ts.entry -side left

frame .zte
label .zte.label -text " Zte:"
entry .zte.entry -textvariable Zte -width 8
pack .zte.label .zte.entry -side left

frame .te
label .te.label -text " tend:"
entry .te.entry -textvariable tend -width 8
pack .te.label .te.entry -side left

frame .mu
label .mu.label -text " mu:"
entry .mu.entry -textvariable mu -width 12
label .mu.fixlabel -text "Fix:"
checkbutton .mu.fixon -text "" -variable fix_mu
pack .mu.label .mu.entry .mu.fixlabel .mu.fixon -side left

frame .k
label .k.label -text " K:"
entry .k.entry -textvariable K -width 12
label .k.fixlabel -text "Fix:"
checkbutton .k.fixon -text "" -variable fix_K
pack .k.label .k.entry .k.fixlabel .k.fixon -side left

frame .c
label .c.label -text " c:"
entry .c.entry -textvariable c -width 12
label .c.fixlabel -text "Fix:"
checkbutton .c.fixon -text "" -variable fix_c
pack .c.label .c.entry .c.fixlabel .c.fixon -side left

frame .alpha
label .alpha.label -text " alpha:"
entry .alpha.entry -textvariable alpha -width 12
label .alpha.fixlabel -text "Fix:"
checkbutton .alpha.fixon -text "" -variable fix_alpha
pack .alpha.label .alpha.entry .alpha.fixlabel .alpha.fixon -side left

frame .p
label .p.label -text " p:" 
entry .p.entry -textvariable p -width 12
label .p.fixlabel -text "Fix:"
checkbutton .p.fixon -text "" -variable fix_p
pack .p.label .p.entry .p.fixlabel .p.fixon -side left

frame .run
label .run.label -text "  Run:  " -bg #000033 -fg yellow
button .run.etasct -text " ETASCT " -command {
set fix [format "%1d%1d%1d%1d%1d" $fix_mu $fix_K $fix_c $fix_alpha $fix_p]; 
set cplotx ""
set coutput ""
if { $iplotx > 0 } { set cplotx "X" }
if { $ioutput > 0 } { set coutput "P" }
if { $ic > 0 } {
   exec $env(ETAS_HOME)/bin/etasct.sh -i$Zts -s$tstart -z$Zte -e$tend -t$Mc -r$Mz -m$mu -K$K -c$c -a$alpha -p$p -f$fix -S$CT1 -E$CT2 -W -O$cplotx$coutput & 
} else {
   exec $env(ETAS_HOME)/bin/etasct.sh -i$Zts -s$tstart -z$Zte -e$tend -t$Mc -r$Mz -m$mu -K$K -c$c -a$alpha -p$p -f$fix -S$CT1 -E$CT2 -D$dT -O$cplotx$coutput & } 
}
pack .run.label .run.etasct -side left

#button .output -text " Output " -command {puts "--> etasimplot.ps"; exec $env(ETAS_HOME)/bin/etasimplot -w10 -oetasimplot.ps; puts "--> etasimxmf.ps"; exec $env(ETAS_HOME)/bin/etasxmf -w10 -oetasimxmf.ps -iwork.etasim &}

checkbutton .plotx -text "Plot X:" -variable iplotx

checkbutton .output -text "Output PS:" -variable ioutput

frame .plot
label .plot.label -text " CT plot:"
button .plot.auto -text " Auto " -command {exec $env(ETAS_HOME)/bin/etasctplot $env(ETAS_OPTION) &}
button .plot.man -text " Manual " -command {exec $env(ETAS_HOME)/bin/etasctplot $env(ETAS_OPTION) -x$xmin -X$xmax -y$ymin -Y$ymax &}
pack .plot.label .plot.auto .plot.man -side left

button .quit -text " Quit " -command {exec $env(ETAS_HOME)/bin/kill_etasct.sh; exit}

frame .x
label .x.label1 -text " xmin:"
entry .x.min -textvariable xmin -width 8
label .x.label2 -text " xmax:"
entry .x.max -textvariable xmax -width 8
pack .x.label1 .x.min .x.label2 .x.max -side left

frame .y
label .y.label1 -text " ymin:"
entry .y.min -textvariable ymin -width 8
label .y.label2 -text " ymax:"
entry .y.max -textvariable ymax -width 8
pack .y.label1 .y.min .y.label2 .y.max -side left

pack .dir .ct1 .ct2 .ic .dt .mc .mz .zts .ts .zte .te .mu .k .c .alpha .p .run .output .plotx .plot .x .y .quit -side top
