#!/usr/bin/wish

set ic 0
set b 0.9
set n 1000
set seed -1

set file etas.out
set fp [open $file r]
gets $fp line
gets $fp line
scan $line "%f %f %f" Zts tend tstart
gets $fp line
scan $line "%f %f" Mc Mz
gets $fp line
scan $line "%f %f %f %f %f" mu K c alpha p
gets $fp line
scan $line "%d %d %d %d %d" fix_mu fix_K fix_c fix_alpha fix_p
gets $fp line
scan $line "%f" aic2
gets $fp line
scan $line "%f" Zte
gets $fp line
scan $line "%f" gradient
close $fp
set aic2 [format "%6g" $aic2]
set gradient [format "%6g" $gradient]

set init_Zts $Zts
set init_tend $tend
set init_tstart $tstart
set init_Zte $Zte

set init_mu $mu
set init_K  $K
set init_c  $c
set init_alpha $alpha
set init_p $p

# MAIN
wm title . "ETASIM Control Panel"
wm geometry . +5+15
wm resizable . 0 0

frame .ic
label .ic.label -text "Magnitude Sequence:"
radiobutton .ic.gr -text "GR" -variable ic -value 0
radiobutton .ic.work -text "work.etas" -variable ic -value 1
radiobutton .ic.bs -text "BootStrap" -variable ic -value 2
#entry .ic.entry -textvariable ic -width 8
#pack .ic.label .ic.entry -side left
pack .ic.label .ic.work .ic.bs .ic.gr -side top

frame .b
label .b.label -text " bValue:" 
entry .b.entry -textvariable b -width 8
pack .b.label .b.entry -side left

frame .nsimu
label .nsimu.label -text " n:"
entry .nsimu.entry -textvariable n -width 8
pack .nsimu.label .nsimu.entry -side left

frame .seed
label .seed.label -text " seed:"
entry .seed.entry -textvariable seed -width 5
pack .seed.label .seed.entry -side left

frame .mc
label .mc.label -text " Mc:"
entry .mc.entry -textvariable Mc -width 5
pack .mc.label .mc.entry -side left

frame .mz
label .mz.label -text " Mz:"
entry .mz.entry -textvariable Mz -width 5
pack .mz.label .mz.entry -side left

frame .ts
label .ts.label -text " Ts:"
entry .ts.entry -textvariable tstart -width 8
pack .ts.label .ts.entry -side left

frame .mu
label .mu.label -text " mu:"
entry .mu.entry -textvariable mu -width 12
pack .mu.label .mu.entry -side left

frame .k
label .k.label -text " K:"
entry .k.entry -textvariable K -width 12
pack .k.label .k.entry -side left

frame .c
label .c.label -text " c:"
entry .c.entry -textvariable c -width 12
pack .c.label .c.entry -side left

frame .alpha
label .alpha.label -text " alpha:"
entry .alpha.entry -textvariable alpha -width 12
pack .alpha.label .alpha.entry -side left

frame .p
label .p.label -text " p:" 
entry .p.entry -textvariable p -width 12
pack .p.label .p.entry -side left

frame .run
label .run.label -text "  Run:  " -bg #000033 -fg yellow
button .run.etasim -text " ETASIM " -command {if { $seed > -1 } {exec $env(ETAS_HOME)/bin/etasim.sh -j$ic -n$n -s$tstart -t$Mc -r$Mz -m$mu -K$K -c$c -a$alpha -p$p -z$seed &} else {exec $env(ETAS_HOME)/bin/etasim.sh -j$ic -n$n -s$tstart -t$Mc -r$Mz -m$mu -K$K -c$c -a$alpha -p$p &}}
pack .run.label .run.etasim -side left

button .mf -text " Mag-Freq " -command {exec $env(ETAS_HOME)/bin/etasxmf $env(ETAS_OPTION) -iwork.resim &}

button .output -text " Output " -command {puts "--> etasimplot.ps"; exec $env(ETAS_HOME)/bin/etasimplot -w10 -oetasimplot.ps; puts "--> etasimxmf.ps"; exec $env(ETAS_HOME)/bin/etasxmf -w10 -oetasimxmf.ps -iwork.resim &}

button .quit -text " Quit " -command {exec $env(ETAS_HOME)/bin/kill_etasim.sh; exit}

pack .ic .b .nsimu .seed .mc .mz .ts .mu .k .c .alpha .p .run .mf .output .quit -side top
